unit uFrame;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, ExtCtrls, Controls, Math,
  ATSynEdit,
  ATSynEdit_Adapter_EControl,
  ecSyntAnal;

{type
  TEditorFramePyEvent = function(AEd: TATSynEdit; AEvent: TAppPyEvent; const AParams: array of string): string of object;}

type
  { TEditorFrame }

  TEditorFrame = class(TFrame)
    //MenuItem1: TMenuItem;
    //MenuItem2: TMenuItem;
    SplitterEds: TSplitter;
    TimerChange: TTimer;
    procedure FrameResize(Sender: TObject);
    procedure SplitterMoved(Sender: TObject);
    procedure TimerChangeTimer(Sender: TObject);
  private
    { private declarations }
    Ed1, Ed2: TATSynEdit;
    FTabCaption: string;
    FTabCaptionFromApi: boolean;
    FTabId: integer;
    FFileName: string;
    FModified: boolean;
    //FNotif: TATFileNotif;
    //FTextCharsTyped: integer;
    //FOnChangeCaption: TNotifyEvent;
    //FOnUpdateStatus: TNotifyEvent;
    //FOnEditorClickMoveCaret: TATSynEditClickMoveCaretEvent;
    //FOnEditorClickEndSelect: TATSynEditClickMoveCaretEvent;
    //FOnFocusEditor: TNotifyEvent;
    //FOnEditorCommand: TATSynEditCommandEvent;
    FOnEditorChangeCaretPos: TNotifyEvent;
    //FOnSaveFile: TNotifyEvent;
    //FOnAddRecent: TNotifyEvent;
    //FOnPyEvent: TEditorFramePyEvent;
    FSplitted: boolean;
    FSplitHorz: boolean;
    FSplitPos: double;
    FActiveAlt: boolean;
    //FLocked: boolean;
    //FTabColor: TColor;
    //FFoldTodo: string;
    //FTopLineTodo: integer;
    //FTabKeyCollectMarkers: boolean;
    //FTagString: string;
    //FNotInRecents: boolean;
    //FMacroRecord: boolean;
    //FMacroString: string;
    //FImage: TImage;
    //FImagePanel: TPanel;
    //FImageFilename: string;
    //procedure DoImagePanelPaint(Sender: TObject);
    //procedure DoOnChangeCaption;
    procedure DoOnChangeCaretPos;
    //procedure DoOnUpdateStatus;
    //procedure EditorClickEndSelect(Sender: TObject; APrevPnt, ANewPnt: TPoint);
    //procedure EditorClickMoveCaret(Sender: TObject; APrevPnt, ANewPnt: TPoint);
    //procedure EditorDrawMicromap(Sender: TObject; C: TCanvas; const ARect: TRect);
    //procedure EditorOnChangeCommon(Sender: TObject);
    //procedure EditorOnChange1(Sender: TObject);
    //procedure EditorOnChange2(Sender: TObject);
    //procedure EditorOnClick(Sender: TObject);
    //procedure EditorOnClickGutter(Sender: TObject; ABand, ALine: integer);
    //procedure EditorOnClickDouble(Sender: TObject; var AHandled: boolean);
    //procedure EditorOnCommand(Sender: TObject; ACmd: integer; const AText: string; var AHandled: boolean);
    //procedure EditorOnCommandAfter(Sender: TObject; ACommand: integer;
    //  const AText: string);
    //procedure EditorOnDrawBookmarkIcon(Sender: TObject; C: TCanvas; ALineNum: integer; const ARect: TRect);
    //procedure EditorOnEnter(Sender: TObject);
    //procedure EditorOnDrawLine(Sender: TObject; C: TCanvas; AX, AY: integer;
    //  const AStr: atString; ACharSize: TPoint; const AExtent: TATIntArray);
    //procedure EditorOnCalcBookmarkColor(Sender: TObject; ABookmarkKind: integer; out AColor: TColor);
    //procedure EditorOnChangeCaretPos(Sender: TObject);
    //procedure EditorOnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    //function GetCommentString: string;
    //function GetEnabledFolding: boolean;
    function GetEncodingName: string;
    //function GetLineEnds: TATLineEnds;
    //function GetNotifEnabled: boolean;
    //function GetNotifTime: integer;
    //function GetReadOnly: boolean;
    //function GetTabKeyCollectMarkers: boolean;
    //function GetUnprintedEnds: boolean;
    //function GetUnprintedEndsDetails: boolean;
    //function GetUnprintedShow: boolean;
    //function GetUnprintedSpaces: boolean;
    procedure InitEditor(var ed: TATSynEdit);
    //procedure NotifChanged(Sender: TObject);
    //procedure SetEnabledFolding(AValue: boolean);
    procedure SetEncodingName(const Str: string);
    procedure SetFileName(const AValue: string);
    //procedure SetLocked(AValue: boolean);
    //procedure SetNotifEnabled(AValue: boolean);
    //procedure SetNotifTime(AValue: integer);
    //procedure SetReadOnly(AValue: boolean);
    //procedure SetTabColor(AColor: TColor);
    //procedure SetUnprintedEnds(AValue: boolean);
    //procedure SetUnprintedEndsDetails(AValue: boolean);
    //procedure SetUnprintedShow(AValue: boolean);
    procedure SetSplitHorz(AValue: boolean);
    procedure SetSplitPos(AValue: double);
    procedure SetSplitted(AValue: boolean);
    procedure SetTabCaption(const AValue: string);
    //procedure SetLineEnds(Value: TATLineEnds);
    //procedure SetUnprintedSpaces(AValue: boolean);
    procedure UpdateEds;
    function GetLexer: TecSyntAnalyzer;
    procedure SetLexer(an: TecSyntAnalyzer);
  protected
    procedure DoOnResize; override;
  public
    { public declarations }
    Adapter: TATAdapterEControl;
    //Groups: TATGroups;
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    function Editor: TATSynEdit;
    function Editor2: TATSynEdit;
    //procedure EditorOnKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    //property ReadOnly: boolean read GetReadOnly write SetReadOnly;
    ///property FileName: string read FFileName write SetFileName;
    property TabCaption: string read FTabCaption write SetTabCaption;
    ///property TabCaptionFromApi: boolean read FTabCaptionFromApi write FTabCaptionFromApi;
    ///property TabId: integer read FTabId;
    ///property Modified: boolean read FModified;
    procedure UpdateModifiedState;
    //property NotifEnabled: boolean read GetNotifEnabled write SetNotifEnabled;
    //property NotifTime: integer read GetNotifTime write SetNotifTime;
    ///property Lexer: TecSyntAnalyzer read GetLexer write SetLexer;
    function LexerName: string;
    //function LexerNameAtPos(Pnt: TPoint): string;
    //property Locked: boolean read FLocked write SetLocked;
    //property CommentString: string read GetCommentString;
    //property TabColor: TColor read FTabColor write SetTabColor;
    //property TabKeyCollectMarkers: boolean read GetTabKeyCollectMarkers write FTabKeyCollectMarkers;
    //property TagString: string read FTagString write FTagString;
    //property NotInRecents: boolean read FNotInRecents write FNotInRecents;
    //property TopLineTodo: integer read FTopLineTodo write FTopLineTodo; //always use it instead of Ed.LineTop
    //property TextCharsTyped: integer read FTextCharsTyped write FTextCharsTyped;
    function IsEmpty: boolean;
    //picture support
    function IsText: boolean;
    //property PictureFileName: string read FImageFilename;
    //function PictureSizes: TPoint;
    //
    //property LineEnds: TATLineEnds read GetLineEnds write SetLineEnds;
    ///property EncodingName: string read GetEncodingName write SetEncodingName;
    //property UnprintedShow: boolean read GetUnprintedShow write SetUnprintedShow;
    //property UnprintedSpaces: boolean read GetUnprintedSpaces write SetUnprintedSpaces;
    //property UnprintedEnds: boolean read GetUnprintedEnds write SetUnprintedEnds;
    //property UnprintedEndsDetails: boolean read GetUnprintedEndsDetails write SetUnprintedEndsDetails;
    ///property Splitted: boolean read FSplitted write SetSplitted;
    ///property SplitHorz: boolean read FSplitHorz write SetSplitHorz;
    property SplitPos: double read FSplitPos write SetSplitPos;
    //property EnabledFolding: boolean read GetEnabledFolding write SetEnabledFolding;
    //file
    //procedure DoFileOpen(const fn: string; AAllowErrorMsgBox: boolean);
    //function DoFileSave(ASaveAs: boolean; ASaveDlg: TSaveDialog; ACheckFilenameOpened: TStrFunction): boolean;
    //procedure DoFileReload_DisableDetectEncoding;
    //procedure DoFileReload;
    //procedure DoSaveHistory;
    //procedure DoSaveHistoryEx(c: TJsonConfig; const path: string);
    //procedure DoLoadHistory;
    //procedure DoLoadHistoryEx(c: TJsonConfig; const path: string);
    //misc
    //function DoPyEvent(AEd: TATSynEdit; AEvent: TAppPyEvent; const AParams: array of string): string;
    //procedure DoRestoreFolding;
    //macro
    //procedure DoMacroStart;
    //procedure DoMacroStop(ACancel: boolean);
    //property MacroRecord: boolean read FMacroRecord;
    //property MacroString: string read FMacroString write FMacroString;

    //events
    //property OnFocusEditor: TNotifyEvent read FOnFocusEditor write FOnFocusEditor;
    //property OnChangeCaption: TNotifyEvent read FOnChangeCaption write FOnChangeCaption;
    //property OnUpdateStatus: TNotifyEvent read FOnUpdateStatus write FOnUpdateStatus;
    //property OnEditorClickMoveCaret: TATSynEditClickMoveCaretEvent read FOnEditorClickMoveCaret write FOnEditorClickMoveCaret;
    //property OnEditorClickEndSelect: TATSynEditClickMoveCaretEvent read FOnEditorClickEndSelect write FOnEditorClickEndSelect;
    //property OnEditorCommand: TATSynEditCommandEvent read FOnEditorCommand write FOnEditorCommand;
    //property OnEditorChangeCaretPos: TNotifyEvent read FOnEditorChangeCaretPos write FOnEditorChangeCaretPos;
    //property OnSaveFile: TNotifyEvent read FOnSaveFile write FOnSaveFile;
    //property OnAddRecent: TNotifyEvent read FOnAddRecent write FOnAddRecent;
    //property OnPyEvent: TEditorFramePyEvent read FOnPyEvent write FOnPyEvent;
  end;

implementation

uses
  uMain;

{$R *.lfm}

var
  FLastTabId: integer = 0;

{ TEditorFrame }

procedure TEditorFrame.FrameResize(Sender: TObject);
begin
  //
end;

procedure TEditorFrame.SplitterMoved(Sender: TObject);
begin
  if FSplitted then
    if FSplitHorz then
      FSplitPos:= Ed2.height/height
    else
      FSplitPos:= Ed2.width/width;
end;

procedure TEditorFrame.TimerChangeTimer(Sender: TObject);
begin
  TimerChange.Enabled:= false;
  //DoPyEvent(Editor, cEventOnChangeSlow, []);
end;

procedure TEditorFrame.DoOnChangeCaretPos;
begin
  if Assigned(FOnEditorChangeCaretPos) then
    FOnEditorChangeCaretPos(Self);
end;

function TEditorFrame.GetEncodingName: string;
begin

end;

procedure TEditorFrame.InitEditor(var ed: TATSynEdit);
begin
  ed:= TATSynEdit.Create(Self);
  ed.Parent:= Self;

  ed.DoubleBuffered:=true;//Для уменьшения мерцания
  ed.Font.Name:= Options.OptFontName;
  ed.Font.Size:= Options.OptFontSize;
  ed.Font.Quality:= Options.OptFontQuality;
  {todo: Возможно добавить бордюр}
  ed.BorderStyle:= bsNone;
  //ed.Keymap:= AppKeymap;
  ed.TabStop:= false;
  ed.OptUnprintedVisible:= Options.OptUnprintedVisible;
  ed.OptRulerVisible:= Options.OptRulerVisible;
  ed.OptScrollbarsNew:= true;

  //ed.OnClick:= @EditorOnClick;
  //ed.OnClickDouble:= @EditorOnClickDouble;
  //ed.OnClickMoveCaret:= @EditorClickMoveCaret;
  //ed.OnClickEndSelect:= @EditorClickEndSelect;
  //ed.OnEnter:= @EditorOnEnter;
  //ed.OnChangeState:= @EditorOnChangeCommon;
  //ed.OnChangeCaretPos:= @EditorOnChangeCaretPos;
  //ed.OnCommand:= @EditorOnCommand;
  //ed.OnCommandAfter:= @EditorOnCommandAfter;
  //ed.OnClickGutter:= @EditorOnClickGutter;
  //ed.OnCalcBookmarkColor:= @EditorOnCalcBookmarkColor;
  //ed.OnDrawBookmarkIcon:= @EditorOnDrawBookmarkIcon;
  //ed.OnDrawLine:= @EditorOnDrawLine;
  //ed.OnKeyDown:= @EditorOnKeyDown;
  //ed.OnKeyUp:=@EditorOnKeyUp;
  //ed.OnDrawMicromap:=@EditorDrawMicromap;
end;

procedure TEditorFrame.SetEncodingName(const Str: string);
begin

end;

procedure TEditorFrame.SetFileName(const AValue: string);
begin

end;

procedure TEditorFrame.SetSplitHorz(AValue: boolean);
begin

end;

procedure TEditorFrame.SetSplitPos(AValue: double);
const
  cMin = 10;
begin
  if not IsText then exit;
  FSplitPos:= AValue;

  if FSplitHorz then
  begin
    Ed2.Height:= Max(cMin, trunc(FSplitPos*Height));
    SplitterEds.Top:= 0;
  end
  else
  begin
    Ed2.Width:= Max(cMin, trunc(FSplitPos*Width));
    SplitterEds.Left:= 0;
  end;
end;

procedure TEditorFrame.SetSplitted(AValue: boolean);
begin

end;

procedure TEditorFrame.SetTabCaption(const AValue: string);
begin

end;

procedure TEditorFrame.UpdateEds;
begin

end;

function TEditorFrame.GetLexer: TecSyntAnalyzer;
begin

end;

procedure TEditorFrame.SetLexer(an: TecSyntAnalyzer);
begin

end;

procedure TEditorFrame.DoOnResize;
begin
  inherited;
  SplitPos:= SplitPos;
end;

constructor TEditorFrame.Create(TheOwner: TComponent);
begin
  inherited;

  FFileName:= '';
  FModified:= false;
  //FActiveAlt:= false;
  //FTabColor:= clNone;
  Inc(FLastTabId);
  FTabId:= FLastTabId;
  //FNotInRecents:= false;

  InitEditor(Ed1);
  InitEditor(Ed2);

  Ed2.Visible:= false;
  SplitterEds.Visible:= false;
  Ed1.Align:= alClient;
  Ed2.Align:= alBottom;

  //Ed1.OnChange:= @EditorOnChange1;
  //Ed2.OnChange:= @EditorOnChange2;
  Ed1.EditorIndex:= 0;
  Ed2.EditorIndex:= 1;

  FSplitHorz:= true;
  FSplitPos:= 0.5;
  //Splitted:= false;

  Adapter:= TATAdapterEControl.Create(Self);
  Adapter.AddEditor(Ed1);
  Adapter.AddEditor(Ed2);
  Ed1.AdapterHilite:= Adapter;
  Ed2.AdapterHilite:= Adapter;

  //load options
  //EditorApplyOps(Ed1, EditorOps, true);
  //EditorApplyOps(Ed2, EditorOps, true);
  //EditorApplyTheme(Ed1);
  //EditorApplyTheme(Ed2);

  //newdoc props
  //Ed1.Strings.Endings:= TATLineEnds(UiOps.NewdocEnds);
  Ed1.Strings.DoClearUndo;
  Ed1.Strings.Modified:= false;
  //Ed1.Strings.EncodingDetectDefaultUtf8:= UiOps.DefaultEncUtf8;

  //EncodingName:= UiOps.NewdocEnc;
  //Lexer:= AppManager.FindAnalyzer(UiOps.NewdocLexer);

  //FNotif:= TATFileNotif.Create(Self);
  //FNotif.Timer.Interval:= 1000;
  //FNotif.Timer.Enabled:= false;
  //FNotif.OnChanged:= @NotifChanged;
end;

destructor TEditorFrame.Destroy;
begin
  inherited Destroy;
end;

function TEditorFrame.Editor: TATSynEdit;
begin
  if FActiveAlt then
    Result:= Ed2
  else
    Result:= Ed1;
end;

function TEditorFrame.Editor2: TATSynEdit;
begin
  if not FActiveAlt then
    Result:= Ed2
  else
    Result:= Ed1;
end;

procedure TEditorFrame.UpdateModifiedState;
begin

end;

function TEditorFrame.LexerName: string;
begin

end;

function TEditorFrame.IsEmpty: boolean;
begin

end;

function TEditorFrame.IsText: boolean;
begin
  Result:=true;
end;

end.

