unit uMain;
{$i Keys.inc}
{$mode objfpc}{$H+}
{$R+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, DefaultTranslator, Graphics,
  Dialogs, ExtCtrls, ComCtrls, Menus, StdCtrls, Buttons, ActnList, StdActns,
  IniFiles, LConvEncoding, LclIntf, LclType,
  ATTabs, ATSynEdit, ATStrings,
  ATStringProc,
  ATSynEdit_CanvasProc,
  ATSynEdit_Adapter_EControl,
  ATSynEdit_Carets,
  ATSynEdit_Export_HTML,
  ATStringProc_WordJump,
  formlexerlib,
  ecSyntAnal,
  proc_lexer,
  proc_editor,
  ResourceStringList, uSettings, uFrame, uGlobal_Data;

type
  TAppFlags = record
    ProjectMode: boolean;//If Project Mode then CurrentPath=ProjectPath for new files
  end;

  { TfmMain }

  TfmMain = class(TForm)
    actFileNew: TAction;
    actOptionsLexersSetup: TAction;
    actLexerLexer: TAction;
    actSaveAll: TAction;
    actSave: TAction;
    actOptionsSettings: TAction;
    actRightClose: TAction;
    actLeftClose: TAction;
    actViewToolbar: TAction;
    actViewStatus: TAction;
    actViewBottom: TAction;
    actViewRight: TAction;
    actViewLeft: TAction;
    actMain: TActionList;
    bevLeft: TBevel;
    bevLeftTop: TBevel;
    bevBottom: TBevel;
    btCloseLeft: TSpeedButton;
    btCloseBottom: TSpeedButton;
    Button1: TButton;
    comboConsole: TComboBox;
    dialogSave: TSaveDialog;
    actFileOpen: TFileOpen;
    actFileOpenProject: TFileOpen;
    actFileSaveAs: TFileSaveAs;
    actFileExit: TFileExit;
    imgIcons: TImageList;
    lblLeft: TLabel;
    lblBottom: TLabel;
    listBottomConsole: TListBox;
    listToDo: TListView;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    mnuViewLexerChange: TMenuItem;
    MnuSep1: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    mnuFileOpen: TMenuItem;
    mnuFileNew: TMenuItem;
    mnuOptions: TMenuItem;
    mnuFile: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    mnuViewLeft: TMenuItem;
    mnuView: TMenuItem;
    nbBottom: TNotebook;
    nbLeft: TNotebook;
    pageToDo: TPage;
    pageConsol: TPage;
    pageProject: TPage;
    pageCode: TPage;
    panBottom: TPanel;
    panCenter: TPanel;
    panEditor: TPanel;
    panLeft: TPanel;
    panRight: TPanel;
    sbStatus: TStatusBar;
    splitBottom: TSplitter;
    splitLeft: TSplitter;
    splitRight: TSplitter;
    tbToDo: TToolBar;
    tbTools: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    btRefresh: TToolButton;
    btGoto: TToolButton;
    btExport: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    tvCode: TTreeView;
    tvProject: TTreeView;
    {Form:}
    procedure FormCreate(Sender: TObject);
    {Form: Перед выходом уничтожаем все редакторы}
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    {Панели: Переключение Тулбара}
    procedure actViewToolbarExecute(Sender: TObject);
    {Панели: Переключение Левой панели}
    procedure actViewLeftExecute(Sender: TObject);
    {Панели: Закрытие Левой панели}
    procedure actLeftCloseExecute(Sender: TObject);
    {Панели: Переключение правой панели}
    procedure actViewRightExecute(Sender: TObject);
    {Панели: Закрытие правой панели}
    procedure actRightCloseExecute(Sender: TObject);
    {Панели: Переключение Нижней панели}
    procedure actViewBottomExecute(Sender: TObject);
    {Панели: Переключение Статус-бара}
    procedure actViewStatusExecute(Sender: TObject);
    {Панели: Открываем страницу в зависимвости от заголовка Таба}
    procedure TabPanelsClick(A: TObject);
    {Диалоги: Подготовка диалога открытия файла}
    procedure actFileOpenBeforeExecute(Sender: TObject);
    {Диалоги: Открытие файла}
    procedure actFileOpenAccept(Sender: TObject);
    {Диалоги: Подготовка диалога открытия проекта}
    procedure actFileOpenProjectBeforeExecute(Sender: TObject);
    {Operations: Сохранение текущего файла}
    procedure actSaveExecute(Sender: TObject);
    {Operatons: Сохранение всех открытых файлов}
    procedure actSaveAllExecute(Sender: TObject);
    {Operatons: Сохранеие файла по номеру}
    function SaveFile(Index: Integer): Integer;
    {Operatons: Добавление нового файла: Добавляется страница, редактор, таб}
    procedure AddFile(FileName: string; CP: String = ''; FileNew: Boolean = true; AfterCurrent: Boolean = false);
    {Tabs: реакция на модификацию файла}
    procedure EditorsOnChange(Sender: TObject);
    {Tabs: При клике на Табе вызывем страницу по реальному номеру таба (по привязке к редактору)}
    procedure TabClickEvent(A: TObject);
    {Tabs: При перетаскивании Табов сохраняем их Реальные номера (привязка к Редакторам и страницам)}
    procedure TabMoveEvent(Sender: TObject; NFrom, NTo: Integer);
    {Tabs: Добавление новой вкладки (вкладка, панель, редактор)  }
    procedure TabPlusClickEvent(Sender: TObject);
    {Tabs: Закрытие файла (Таба, редактора, страницы)}
    procedure TabCloseEvent(Sender: TObject; ATabIndex: Integer; var ACanClose, ACanContinue: boolean);
    {Settings: Считывание настроек (сохранение дефолтных, при отсутствии файла настроек)}
    procedure ReadSettings;
    {Settings: Сохранение настроек}
    procedure WriteSettings;
    {Setting: Диалог настроек}
    procedure actOptionsSettingsExecute(Sender: TObject);
    {Settings: Применение настроек}
    procedure ApplySettings;
    {Settings&Lexer: Настройки библиотеки Лексеров}
    procedure actOptionsLexersSetupExecute(Sender: TObject);
    {Lexer: Получаем список Лексеров}
    procedure UpdateLexList;
    {Lexer: Очистка дерева}
    procedure AdapterParseBegin(Sender: TObject);
    {Lexer: Заполнение дерева по результатам парсинга}
    procedure AdapterParseDone(Sender: TObject);
    {Lexer: Показывает на дереве, где находимся}
    procedure EditorChangeCaretPos(Sender: TObject);
    {Lexer: Переход с узла дерева}
    procedure tvCodeClick(Sender: TObject);
    {Lexer: Комментирование выделенных строк, комментарием из Лексера}
    procedure DoCommentAct(Act: TATCommentAction);
    {Lexer: Получение символа коментария из текущего Лексера}
    function GetComment: string;
    {Lexer: Включение/отключение Лексера}
    procedure actLexerLexerExecute(Sender: TObject);
    {Lexer: Выбор Лексера (из меню/тулбара)}
    procedure MenuChangeLexerClick(Sender: TObject);
    {Consol: Выполнение комнды по нажатию Enter}
    procedure comboConsoleKeyPress(Sender: TObject; var Key: char);
    {Bookmarks: Переключение закладки}
    procedure EditClickGutter(Sender: TObject; ABand, ALine: integer);
    {Bookmarks: Рисование закладки}
    procedure OnDrawBookmarkIcon(Sender: TObject; C: TCanvas; ALineNum: integer;
  const ARect: TRect);
    {Functions: Поиск узла по имени }
    function GetNodeByName(ATree: TTreeView; ACaption: String): TTreeNode;
    {Functions: Получение слова под курсором мыши, номера строки, смещение 1го и последнего символов слова}
    function GetWordByCoords(AEditor: TATSynEdit; const Coords: TPoint; out
      APosition: TPoint; out AOffset1, AOffset2: Integer): String;
    {Hints: Поиск метки/команды под курсором, вывод Хинта}
    procedure EditorMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    {Operations: Переход по ссылке}
    procedure EditorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    function GetFrame(N: integer): TEditorFrame;
    function DoFileOpen(AFilename: string{; APages: TATPages=nil}): TEditorFrame;
    function DoTabAdd({Pages: TATPages; }const ACaption: string): TATTabData;
  public
    { public declarations }
    tabsLeft: TATTabs;
    tabsEditor: TATTabs;
    tabsBottom: TATTabs;
    //t: TATTabs;
    property Frames[N: integer]: TEditorFrame read GetFrame;
  end;

{type
  TEditorFile = record
    FileName: String;
    FilePath: String;
    TabName: String;
    LexerName: String;
    LexerStatus: Boolean;
    FirstSaveFlag: Boolean;
    RealTabNumber: Integer;
    Adapter: TATAdapterEControl;
    Editor: TATSynEdit;
  end;

  TEditorFiles = Array of TEditorFile; }

  { TEditors }

 { TEditors = class(TObject)
  private
    FIndex: Integer;
    FCount: Integer;
    FFiles: TEditorFiles;
    FLexerName: String;
    FLexerStatus: Boolean;
    //Events
    FOnChangeCaretPos: TNotifyEvent;
    FOnClickGutter: TATSynEditClickGutterEvent;
    FOnDrawBookmarkIcon: TATSynEditDrawBookmarkEvent;
    FOnParseBegin: TNotifyEvent;
    FOnParseDone: TNotifyEvent;
    FOnEditorMouseMove: TMouseMoveEvent;
    FOnEditorMouseUp: TMouseEvent;
    function GetLexerName: String;
    function GetLexerStatus: Boolean;
    function GetTabName(FileName: String; var DoublesCount: Integer): String;
    function GetFileByTab(TabIndex: Integer): Integer;
    procedure SetIndex(AValue: integer);
    procedure SetLexer(ALexerName: String);
    procedure SwitchLexer(AOn: Boolean);
  Protected
  Public
    Constructor Create;
    Property Index: integer Read FIndex Write SetIndex;
    Property Count: integer Read FCount;
    Property LexerName: String Read GetLexerName Write SetLexer;
    Property LexerStatus: Boolean Read GetLexerStatus Write SwitchLexer;
    Property Items: TEditorFiles Read FFiles Write FFiles;
    //Events
    Property OnChangeCaretPos: TNotifyEvent Read FOnChangeCaretPos Write FOnChangeCaretPos;
    Property OnClickGutter: TATSynEditClickGutterEvent Read FOnClickGutter Write FOnClickGutter;
    Property OnDrawBookmarkIcon: TATSynEditDrawBookmarkEvent Read FOnDrawBookmarkIcon Write FOnDrawBookmarkIcon;
    Property OnParseBegin: TNotifyEvent Read FOnParseBegin Write FOnParseBegin;
    Property OnParseDone: TNotifyEvent Read FOnParseDone Write FOnParseDone;
    Property OnEditorMouseMove: TMouseMoveEvent Read FOnEditorMouseMove Write FOnEditorMouseMove;
    Property OnEditorMouseUp: TMouseEvent Read FOnEditorMouseUp Write FOnEditorMouseUp;
    procedure Add(Parent: TComponent; CodeTree: TTreeView; FileName: string);
    procedure Delete(AIndex: Integer);
    procedure Clear;
    procedure GetSettings(AIndex: Integer);
    Destructor Destroy; override;
  end;                     }

var
  fmMain: TfmMain;
  Options: TAppOptions;
  Flags: TAppFlags;
  ProjectPath: String;
  CurrentPath: String;
  //Editors: TEditors;
  SynManager: TecSyntaxManager;
  Adapter: TATAdapterEControl;
  LexerList: TStringList;

const
  LexerFileName='LexLib.lxl';

implementation

{$R *.lfm}

{ TEditors }
{
//Получение имени Таба (и страницы) - исключение дублирующихся имен
function TEditors.GetTabName(FileName: String; var DoublesCount: Integer
  ): String;
var
  tpFileName: String;
  tpFileExt: String;
  i: Integer;
begin
  if DoublesCount=0 then begin
    Dec(DoublesCount);
    for i:=0 to FCount-1 do if FFiles[i].FileName=FileName then Inc(DoublesCount);
  end;
  if DoublesCount=0 then tpFileName:=FileName else begin
    tpFileExt:=ExtractFileExt(FileName);
    tpFileName:=Format('%s(%d)%s',[Copy(FileName,1,Length(FileName)-Length(tpFileExt)),
    DoublesCount,tpFileExt]);
  end;
  for i:=0 to FCount-1 do if FFiles[i].TabName=tpFileName then begin
    Inc(DoublesCount);
    tpFileName:=GetTabName(FileName,DoublesCount);
    break;
  end;
  Result:=tpFileName;
end;                }
 {
//Получение имени Лексера текущего редатора
function TEditors.GetLexerName: String;
begin
  Result:=FFiles[FIndex].LexerName;
end;        }
 {
//Получение состояния Лексера (on/off) текущего редактора
function TEditors.GetLexerStatus: Boolean;
begin
  Result:=FFiles[FIndex].LexerStatus;
end;      }
     {
//Получение номера редактора по номеру Таба
function TEditors.GetFileByTab(TabIndex: Integer): Integer;
var
  i: Integer;
begin
  Result:=-1;
  for i:=0 to FCount-1 do if FFiles[i].RealTabNumber=TabIndex then begin
    Result:=i;
    break;
  end;
end;
        }{
//Создание массива Редакторов
constructor TEditors.Create;
begin
  FCount:=0;
  FIndex:=-1;
  SetLength(FFiles,FCount);
end;
           }{
//Установка выбранного редактора
procedure TEditors.SetIndex(AValue: integer);
begin
  if (FIndex=AValue) or (AValue>=FCount) then Exit;
  //if (FIndex<>-1) and (FIndex<FCount) then FFiles[FIndex].Panel.Hide;
  if (FIndex<>-1) and (FIndex<FCount) then FFiles[FIndex].Editor.Hide;
  FIndex:=AValue;
  if FIndex<>-1 then begin
    FLexerName:=FFiles[FIndex].LexerName;
    FLexerStatus:=FFiles[FIndex].LexerStatus;
    FFiles[FIndex].Editor.Show;
    FFiles[Findex].Editor.SetFocus;
    FFiles[Findex].Editor.Invalidate;
  end;
end;
           }{
//Установка выбранного Лексера
procedure TEditors.SetLexer(ALexerName: String);
begin
  FFiles[Index].Adapter.Lexer:=SynManager.FindAnalyzer(ALexerName);
  if FFiles[Index].Adapter<>nil then begin
    FFiles[Index].LexerName:=ALexerName;
    FLexerName:=ALexerName;
    FLexerStatus:=true;
  end
  else begin
    FFiles[Index].LexerName:='';
    FLexerName:='';
    FLexerStatus:=false;
  end;
end;
            }{
{ TODO -cbugmemory : 1 ошибка }
//Переключение состояния Лексера (вкл/выкл) текущего редактора
procedure TEditors.SwitchLexer(AOn: Boolean);
begin
  {if AOn then begin
    FFiles[Index].Adapter.Lexer:=SynManager.FindAnalyzer(FLexerName);
    if FFiles[Index].Adapter<>nil then begin
      FLexerStatus:=true;
      FFiles[Index].LexerStatus:=true;
    end
    else begin
      FLexerStatus:=false;
      FFiles[Index].LexerStatus:=false;
    end;
  end else begin
    FFiles[Index].Adapter.Lexer:=nil;
    FFiles[Index].LexerStatus:=false;
    FLexerStatus:=false;
  end;
  FFiles[Index].Editor.Update;}
end;
              }{
//Добавление редактора в массив
{ TODO -cEditor : Доделать все настройки }
procedure TEditors.Add(Parent: TComponent; CodeTree: TTreeView; FileName: string);
var
  DCounter: Integer = 0;
  Analyzer: TecSyntAnalyzer;
begin
  Inc(FCount);
  SetLength(FFiles,FCount);
  FFiles[FCount-1].FilePath:=ExtractFilePath(FileName);
  FFiles[FCount-1].FileName:=ExtractFileName(FileName);
  FFiles[FCount-1].TabName:=GetTabName(FFiles[FCount-1].FileName, DCounter);
  FFiles[FCount-1].RealTabNumber:=-1;
  FFiles[FCount-1].FirstSaveFlag:=true;
  FFiles[FCount-1].Editor:=TATSynEdit.Create(Parent);
  FFiles[FCount-1].Editor.Parent:=(Parent as TWinControl);

  FFiles[FCount-1].Editor.Align:=alClient;
  FFiles[FCount-1].Editor.BorderStyle:=bsSingle;
  FFiles[FCount-1].Editor.ShowHint:=true;
  //Устанавливаем нужные опции из настроек
  GetSettings(FCount-1);
  //Events
  FFiles[FCount-1].Editor.OnChangeCaretPos:=FOnChangeCaretPos;
  FFiles[FCount-1].Editor.OnClickGutter:=FOnClickGutter;
  FFiles[FCount-1].Editor.OnDrawBookmarkIcon:=FOnDrawBookmarkIcon;
  FFiles[FCount-1].Editor.OnMouseMove:=FOnEditorMouseMove;
  FFiles[FCount-1].Editor.OnMouseUp:=FOnEditorMouseUp;
  //Создаем адаптер подсветки
  FFiles[FCount-1].Adapter:=TATAdapterEControl.Create(Parent);
  FFiles[FCount-1].Editor.AdapterHilite:=FFiles[FCount-1].Adapter;
  FFiles[FCount-1].Adapter.Lexer:= nil;
  FFiles[FCount-1].Adapter.OnParseBegin:=FOnParseBegin;
  FFiles[FCount-1].Adapter.OnParseDone:=FOnParseDone;
  CodeTree.Items.Clear;
  //Analyzer:=DoFindLexerForFilename(SynManager, FFiles[FCount-1].FileName);
  SetIndex(FCount-1);
  //SetLexer(Analyzer.LexerName);
  SwitchLexer(true);
  //Analyzer.Free;
end;
                  }{
{ TODO -cEditors.Delete : Проверить на утечки памяти }
procedure TEditors.Delete(AIndex: Integer);
var
  i: Integer;
begin
  Dec(FCount);
  FFiles[AIndex].Adapter.Lexer.Free;
  FFiles[AIndex].Adapter.Free;
  FFiles[AIndex].Adapter:=nil;
  FFiles[AIndex].Editor.Strings.Free;
  FFiles[AIndex].Editor.Free;
  FFiles[AIndex].Editor:=nil;
  for i:=AIndex to FCount-1 do FFiles[i]:=FFiles[i+1];
  SetLength(FFiles,FCount);
  if FIndex>=AIndex then SetIndex(FIndex-1);
end;
                    }{
{ TODO -cEditors.Destroy : Проверить на утечки памяти }
//Уничтожение редакторов
procedure TEditors.Clear;
var
  i: Integer;
begin
  for i:=0 to FCount-1 do begin
    FFiles[i].Adapter.Lexer:=nil;
    FFiles[i].Adapter.Free;
    FFiles[i].Editor.Free;
  end;
  FCount:=0;
  SetLength(FFiles,FCount);
  FIndex:=-1;
end;
                   }{
procedure TEditors.GetSettings(AIndex: Integer);
begin
  //General
  FFiles[AIndex].Editor.OptShowCurLine            :=Options.OptShowCurLine;
  FFiles[AIndex].Editor.OptShowCurLineMinimal     :=Options.OptShowCurLineMinimal;
  FFiles[AIndex].Editor.OptShowCurColumn          :=Options.OptShowCurColumn;
  FFiles[AIndex].Editor.OptLastLineOnTop          :=Options.OptLastLineOnTop;
  FFiles[AIndex].Editor.OptShowFullSel            :=Options.OptShowFullSel;
  FFiles[AIndex].Editor.OptShowFullHilite         :=Options.OptShowFullHilite;
  FFiles[AIndex].Editor.OptShowIndentLines        :=Options.OptShowIndentLines;
  FFiles[AIndex].Editor.OptShowScrollHint         :=Options.OptShowScrollHint;
  FFiles[AIndex].Editor.OptTextHint               :=Options.OptTextHint;
  FFiles[AIndex].Editor.OptWordChars              :=UnicodeString(Options.OptWordChars);
  FFiles[AIndex].Editor.OptOverwriteAllowedOnPaste:=Options.OptOverwriteAllowedOnPaste;
  FFiles[AIndex].Editor.OptCopyLinesIfNoSel       :=Options.OptCopyLinesIfNoSel;
  FFiles[AIndex].Editor.OptCutLinesIfNoSel        :=Options.OptCutLinesIfNoSel;
  FFiles[AIndex].Editor.OptSavingTrimSpaces       :=Options.OptSavingTrimSpaces;
  FFiles[AIndex].Editor.OptSavingForceFinalEol    :=Options.OptSavingForceFinalEol;
  //Gutter
  FFiles[AIndex].Editor.OptNumbersStyle           :=TATSynNumbersStyle(Options.OptNumbersStyle);
  FFiles[AIndex].Editor.OptNumbersAlignment       :=TAlignment(Options.OptNumbersAlignment);
  FFiles[AIndex].Editor.OptNumbersShowFirst       :=Options.OptNumbersShowFirst;
  FFiles[AIndex].Editor.OptNumbersSkippedChar     :=UnicodeString(Options.OptNumbersSkippedChar);
  FFiles[AIndex].Editor.OptNumbersShowCarets      :=Options.OptNumbersShowCarets;
  FFiles[AIndex].Editor.OptShowGutterCaretBG      :=Options.OptShowGutterCaretBG;
  FFiles[AIndex].Editor.OptNumbersFontSize        :=Options.OptNumbersFontSize;
  FFiles[AIndex].Editor.OptGutterShowFoldAlways   :=Options.OptGutterShowFoldAlways;
  FFiles[AIndex].Editor.OptGutterShowFoldLines    :=Options.OptGutterShowFoldLines;
  FFiles[AIndex].Editor.OptGutterShowFoldLinesAll :=Options.OptGutterShowFoldLinesAll;
  FFiles[AIndex].Editor.OptGutterPlusSize         :=Options.OptGutterPlusSize;
  FFiles[AIndex].Editor.OptRulerSize              :=Options.OptRulerSize;
  FFiles[AIndex].Editor.OptRulerFontSize          :=Options.OptRulerFontSize;
  FFiles[AIndex].Editor.OptRulerTextIndent        :=Options.OptRulerTextIndent;
  FFiles[AIndex].Editor.OptUnprintedVisible:=false;
  //Unprintable
  FFiles[AIndex].Editor.OptUnprintedVisible        :=Options.OptUnprintedVisible;
  FFiles[AIndex].Editor.OptUnprintedSpaces         :=Options.OptUnprintedSpaces;
  FFiles[AIndex].Editor.OptUnprintedEnds           :=Options.OptUnprintedEnds;
  FFiles[AIndex].Editor.OptUnprintedEndsDetails    :=Options.OptUnprintedEndsDetails;
  //Colors
  FFiles[AIndex].Editor.Colors.BlockSepLine      :=Options.BlockSepLine      ;
  FFiles[AIndex].Editor.Colors.BlockStaple       :=Options.BlockStaple       ;
  FFiles[AIndex].Editor.Colors.BookmarkBG        :=Options.BookmarkBG        ;
  FFiles[AIndex].Editor.Colors.BorderLine        :=Options.BorderLine        ;
  FFiles[AIndex].Editor.Colors.Caret             :=Options.Caret             ;
  FFiles[AIndex].Editor.Colors.CollapseLine      :=Options.CollapseLine      ;
  FFiles[AIndex].Editor.Colors.CollapseMarkBG    :=Options.CollapseMarkBG    ;
  FFiles[AIndex].Editor.Colors.CollapseMarkBorder:=Options.CollapseMarkBorder;
  FFiles[AIndex].Editor.Colors.CollapseMarkFont  :=Options.CollapseMarkFont  ;
  FFiles[AIndex].Editor.Colors.ComboboxArrow     :=Options.ComboboxArrow     ;
  FFiles[AIndex].Editor.Colors.ComboboxArrowBG   :=Options.ComboboxArrowBG   ;
  FFiles[AIndex].Editor.Colors.CurrentLineBG     :=Options.CurrentLineBG     ;
  FFiles[AIndex].Editor.Colors.GutterBG          :=Options.GutterBG          ;
  FFiles[AIndex].Editor.Colors.GutterCaretBG     :=Options.GutterCaretBG     ;
  FFiles[AIndex].Editor.Colors.GutterCaretFont   :=Options.GutterCaretFont   ;
  FFiles[AIndex].Editor.Colors.GutterFoldBG      :=Options.GutterFoldBG      ;
  FFiles[AIndex].Editor.Colors.GutterFoldLine    :=Options.GutterFoldLine    ;
  FFiles[AIndex].Editor.Colors.GutterFont        :=Options.GutterFont        ;
  FFiles[AIndex].Editor.Colors.GutterPlusBG      :=Options.GutterPlusBG      ;
  FFiles[AIndex].Editor.Colors.GutterPlusBorder  :=Options.GutterPlusBorder  ;
  FFiles[AIndex].Editor.Colors.GutterSeparatorBG :=Options.GutterSeparatorBG ;
  FFiles[AIndex].Editor.Colors.IndentVertLines   :=Options.IndentVertLines   ;
  FFiles[AIndex].Editor.Colors.Links             :=Options.Links             ;
  FFiles[AIndex].Editor.Colors.LockedBG          :=Options.LockedBG          ;
  FFiles[AIndex].Editor.Colors.MarginCaret       :=Options.MarginCaret       ;
  FFiles[AIndex].Editor.Colors.MarginRight       :=Options.MarginRight       ;
  FFiles[AIndex].Editor.Colors.MarginUser        :=Options.MarginUser        ;
  FFiles[AIndex].Editor.Colors.MarkedLinesBG     :=Options.MarkedLinesBG     ;
  FFiles[AIndex].Editor.Colors.Markers           :=Options.Markers           ;
  FFiles[AIndex].Editor.Colors.MinimapBorder     :=Options.MinimapBorder     ;
  FFiles[AIndex].Editor.Colors.MinimapSelBG      :=Options.MinimapSelBG      ;
  FFiles[AIndex].Editor.Colors.RulerBG           :=Options.RulerBG           ;
  FFiles[AIndex].Editor.Colors.RulerFont         :=Options.RulerFont         ;
  FFiles[AIndex].Editor.Colors.StateAdded        :=Options.StateAdded        ;
  FFiles[AIndex].Editor.Colors.StateChanged      :=Options.StateChanged      ;
  FFiles[AIndex].Editor.Colors.StateSaved        :=Options.StateSaved        ;
  FFiles[AIndex].Editor.Colors.TextBG            :=Options.TextBG            ;
  FFiles[AIndex].Editor.Colors.TextDisabledBG    :=Options.TextDisabledBG    ;
  FFiles[AIndex].Editor.Colors.TextDisabledFont  :=Options.TextDisabledFont  ;
  FFiles[AIndex].Editor.Colors.TextFont          :=Options.TextFont          ;
  FFiles[AIndex].Editor.Colors.TextHintFont      :=Options.TextHintFont      ;
  FFiles[AIndex].Editor.Colors.TextSelBG         :=Options.TextSelBG         ;
  FFiles[AIndex].Editor.Colors.TextSelFont       :=Options.TextSelFont       ;
  FFiles[AIndex].Editor.Colors.UnprintedBG       :=Options.UnprintedBG       ;
  FFiles[AIndex].Editor.Colors.UnprintedFont     :=Options.UnprintedFont     ;
  FFiles[AIndex].Editor.Colors.UnprintedHexFont  :=Options.UnprintedHexFont  ;
end;
                    }{
destructor TEditors.Destroy;
begin
  Clear;
  inherited;
end;
                   }
{ TfmMain }

//Создание формы: считывание настроек, создание табов панелей, настройки путей,
//создание массива редакторов, создание файла noname.a80
procedure TfmMain.FormCreate(Sender: TObject);
var
  filePath: String;
  mnuLexerItem: TMenuItem;
  i: Integer;
begin
  ReadSettings;

  {$IFDEF tabaftercurrent} Options.NewTabAfterCurrent:=true; {$ELSE} Options.NewTabAfterCurrent:=false; {$ENDIF}

  if Options.SaveCurrentPath then CurrentPath:=Options.CurrentPath
  else CurrentPath:=ExtractFilePath(Application.ExeName);
  ProjectPath:=Options.ProjectsPath;
  if ProjectPath='' then ProjectPath:=ExtractFilePath(Application.ExeName);
  {
  //Создание массива редакторов, назначение событий
  Editors:=TEditors.Create;
  Editors.OnChangeCaretPos:=@EditorChangeCaretPos;
  Editors.OnClickGutter:=@EditClickGutter;
  Editors.OnDrawBookmarkIcon:=@OnDrawBookmarkIcon;
  Editors.OnParseBegin:=@AdapterParseBegin;
  Editors.OnParseDone:=@AdapterParseDone;
  Editors.OnEditorMouseMove:=@EditorMouseMove;
  Editors.OnEditorMouseUp:=@EditorMouseUp; }

  //Panels
  actViewToolbar.Checked:=not Options.ShowToolBar;
  actViewLeft.Checked   :=not Options.ShowLeftPanel;
  actViewRight.Checked  :=not Options.ShowRightPanel;
  actViewBottom.Checked :=not Options.ShowBottomPanel;
  actViewStatus.Checked :=not Options.ShowStatus;
  actViewToolbar.Execute;
  actViewLeft.Execute;
  actViewRight.Execute;
  actViewBottom.Execute;
  actViewStatus.Execute;

  //Left Panel Tabs
  tabsLeft:= TATTabs.Create(Self);
  tabsLeft.Parent:= panLeft;
  //Sizes and View
  tabsLeft.Align:= alBottom;
  tabsLeft.TabBottom:=true;//Tabs at bottom
  tabsLeft.TabWidthMin:=18;//Tabs min Size
  tabsLeft.TabWidthMax:=50;//Tabs max Size
  tabsLeft.TabHeight:=20;
  tabsLeft.TabIndentInit:=2;//Indent from Left
  tabsLeft.TabIndentTop:=0;//Indent from Top
  tabsLeft.TabShowClose:=tbShowNone;//Don't show "X" button
  tabsLeft.TabShowMenu:=false;//Dont't show "Menu" button
  tabsLeft.TabShowPlus:=false;//Dont't show "+" button
  tabsLeft.TabAngle:=0;//Angle of Tabs left/right border
  tabsLeft.Height:=tabsLeft.TabHeight+1;//Height of Tabs = Height of Tab (No Free Space)
  //Actions
  tabsLeft.TabMiddleClickClose:=false;//Disable close tab by middle-click
  tabsLeft.TabDoubleClickClose:=false;//Disable close tab by double-click
  //Colors
  tabsLeft.ColorBg:=clForm;//BG color (visible at top and between tabs)
  tabsLeft.ColorTabActive:=clForm;//BG color of active tab
  tabsLeft.ColorTabPassive:=clForm;//BG color of passive tab
  tabsLeft.ColorBorderActive:=cl3DShadow;//Border Color of active tab
  tabsLeft.ColorBorderPassive:=clInactiveBorder;//Border Color of passive tab
  //Events
  tabsLeft.OnTabClick:=@TabPanelsClick;//Click Event
  //Add tabs
  tabsLeft.AddTab(-1, stTabCodeCaption);
  tabsLeft.AddTab(-1, stTabProjectCaption);
  //Очищаем деревья кода и проекта
  tvProject.Items.Clear;
  tvCode.Items.Clear;
  //Caption of Active tab
  TabPanelsClick(tabsLeft);

  //Bottom Panel Tabs
  tabsBottom:= TATTabs.Create(Self);
  tabsBottom.Parent:=panBottom;
  //Sizes and View
  tabsBottom.Align:= alBottom;
  tabsBottom.TabBottom:=true;//Tabs at bottom
  tabsBottom.TabWidthMin:=18;//Tabs min Size
  tabsBottom.TabWidthMax:=50;//Tabs max Size
  tabsBottom.TabHeight:=20;
  tabsBottom.TabIndentInit:=2;//Indent from Left
  tabsBottom.TabIndentTop:=0;//Indent from Top
  tabsBottom.TabShowClose:=tbShowNone;//Don't show "X" button
  tabsBottom.TabShowMenu:=false;//Dont't show "Menu" button
  tabsBottom.TabShowPlus:=false;//Dont't show "+" button
  tabsBottom.TabAngle:=0;//Angle of Tabs left/right border
  tabsBottom.Height:=tabsLeft.TabHeight+1;//Height of Tabs = Height of Tab (No Free Space)
  //Actions
  tabsBottom.TabMiddleClickClose:=false;//Disable close tab by middle-click
  tabsBottom.TabDoubleClickClose:=false;//Disable close tab by double-click
  //Colors
  tabsBottom.ColorBg:=clForm;//BG color (visible at top and between tabs)
  tabsBottom.ColorTabActive:=clForm;//BG color of active tab
  tabsBottom.ColorTabPassive:=clForm;//BG color of passive tab
  tabsBottom.ColorBorderActive:=cl3DShadow;//Border Color of active tab
  tabsBottom.ColorBorderPassive:=clInactiveBorder;//Border Color of passive tab
  //Events
  tabsBottom.OnTabClick:=@TabPanelsClick;//Click Event
  //Add tabs
  tabsBottom.AddTab(-1, stTabConsoleCaption);
  tabsBottom.AddTab(-1, stTabToDoCaption);
  //Caption of Active tab
  TabPanelsClick(tabsBottom);

  //Editor Tabs
  tabsEditor:= TATTabs.Create(Self);
  tabsEditor.Parent:=panCenter;
  //Sizes and View
  tabsEditor.Align:= alTop;
  tabsEditor.TabBottom:=false;//Tabs at bottom
  tabsEditor.TabWidthMin:=18;//Tabs min Size
  //tabsEditor.TabWidthMax:=50;//Tabs max Size
  tabsEditor.TabHeight:=20;
  tabsEditor.TabIndentInit:=2;//Indent from Left
  tabsEditor.TabIndentTop:=0;//Indent from Top
  tabsEditor.TabShowClose:=tbShowMouseOver;//Don't show "X" button
  tabsEditor.TabShowMenu:=true;//Dont't show "Menu" button
  tabsEditor.TabShowPlus:=true;//Dont't show "+" button
  tabsEditor.TabAngle:=0;//Angle of Tabs left/right border
  tabsEditor.Height:=tabsLeft.TabHeight+1;//Height of Tabs = Height of Tab (No Free Space)
  //Actions
  tabsEditor.TabMiddleClickClose:=false;//Disable close tab by middle-click
  tabsEditor.TabDoubleClickClose:=false;//Disable close tab by double-click
  //Colors
  tabsEditor.ColorBg:=clForm;//BG color (visible at top and between tabs)
  tabsEditor.ColorTabActive:=clForm;//BG color of active tab
  tabsEditor.ColorTabPassive:=clForm;//BG color of passive tab
  tabsEditor.ColorBorderActive:=cl3DShadow;//Border Color of active tab
  tabsEditor.ColorBorderPassive:=clInactiveBorder;//Border Color of passive tab
  //Events
  tabsEditor.OnTabClick:=@TabClickEvent;//Click Event
  tabsEditor.OnTabClose:=@TabCloseEvent;//Close Tab event
  //tabsEditor.OnTabMenu:=;
  tabsEditor.OnTabMove:=@TabMoveEvent;
  //tabsEditor.OnTabOver:=;
  tabsEditor.OnTabPlusClick:=@TabPlusClickEvent;
  //tabsEditor.OnContextPopup:=;

  //Создаем Синтакс-менеджер, загружаем Лексеры, получаем список
  SynManager:= TecSyntaxManager.Create(Self);
  SynManager.LoadFromFile(ExtractFilePath(Application.ExeName)+LexerFileName);
  { TODO -cLexerList : Удалить этот список, при закрытии (onClose) }
  LexerList:=TStringList.Create;
  UpdateLexList;
  //Добавляем полученный список лексеров в меню
  for i:=0 to LexerList.Count-1 do begin
    mnuLexerItem:=TMenuItem.Create(Self);
    mnuLexerItem.Caption:=LexerList[i];
    mnuLexerItem.AutoCheck:=true;
    mnuLexerItem.RadioItem:=true;
    mnuLexerItem.GroupIndex:=1;
    mnuLexerItem.OnClick:=@MenuChangeLexerClick;
    mnuViewLexerChange.Add(mnuLexerItem);
  end;

  if Flags.ProjectMode then filePath:=ProjectPath else filePath:=CurrentPath;
  {if Options.NewTabAfterCurrent then AddFile(filePath+'noname.a80','CP866',true,true)
  else AddFile(filePath+'noname.a80','CP866');   }
  DoFileOpen('');
end;

//Form: Перед выходом уничтожаем все редакторы
{ TODO -cClose : Необходима проверка на, закрытие несохраненных файлов, возможно удаление табов и страниц. }
procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose:=false;
  //Сохранение всего, выход по запросу
  //Editors.Free;
  SynManager.Free;
  LexerList.Free;
  CanClose:=true;
end;

//Панели: Переключение Тулбара
procedure TfmMain.actViewToolbarExecute(Sender: TObject);
begin
  tbTools.Visible:=actViewToolbar.Checked;
end;

//Панели: Переключение Левой панели
procedure TfmMain.actViewLeftExecute(Sender: TObject);
begin
  panLeft.Visible:=actViewLeft.Checked;
  splitLeft.Visible:=actViewLeft.Checked;
end;

//Панели: Закрытие Левой панели
procedure TfmMain.actLeftCloseExecute(Sender: TObject);
begin
  panLeft.Visible:=false;
  splitLeft.Visible:=false;
  actViewLeft.Checked:=false;
end;

//Панели: Переключение правой панели
procedure TfmMain.actViewRightExecute(Sender: TObject);
begin
  panRight.Visible:=actViewRight.Checked;
  splitRight.Visible:=actViewRight.Checked;
end;

//Панели: Закрытие правой панели
procedure TfmMain.actRightCloseExecute(Sender: TObject);
begin
  panRight.Visible:=false;
  splitRight.Visible:=false;
  actViewRight.Checked:=false;
end;

//Панели: Переключение Нижней панели
procedure TfmMain.actViewBottomExecute(Sender: TObject);
begin
  panBottom.Visible:=actViewBottom.Checked;
  splitBottom.Visible:=actViewBottom.Checked;
end;

//Панели: Переключение Статус-бара
procedure TfmMain.actViewStatusExecute(Sender: TObject);
begin
  sbStatus.Visible:=actViewStatus.Checked;
end;

//Панели: Открываем страницу в зависимвости от заголовка Таба
procedure TfmMain.TabPanelsClick(A: TObject);
var
  d: TATTabData;
begin
  d:=(A as TATTabs).GetTabData((A as TATTabs).TabIndex);
  if d.TabCaption=stTabCodeCaption then begin
    lblLeft.Caption:=stCodeCaption;
    nbLeft.PageIndex:=0;
  end
  else if d.TabCaption=stTabProjectCaption then begin
    lblLeft.Caption:=stProjectCaption;
    nbLeft.PageIndex:=1;
  end
  else if d.TabCaption=stTabConsoleCaption then begin
    lblBottom.Caption:=stConsoleCaption;
    nbBottom.PageIndex:=0;
  end
  else if d.TabCaption=stTabToDoCaption then begin
    lblBottom.Caption:=stToDoCaption;
    nbBottom.PageIndex:=1;
  end
end;

//Диалоги: Подготовка диалога открытия файла
{ TODO -cOpenFile : Здесь предусмотреть реакцию на открытие Проекта, Текста... }
procedure TfmMain.actFileOpenBeforeExecute(Sender: TObject);
var
  Path: String;
begin
  if CurrentPath='' then
    if Flags.ProjectMode then Path:=Options.ProjectsPath else Path:=Options.CurrentPath
  else Path:=CurrentPath;
  if Path='' then Path:=ExtractFilePath(Application.ExeName);
  actFileOpen.Dialog.Title:=stOpenTitle;
  actFileOpen.Dialog.InitialDir:=Path;
  actFileOpen.Dialog.Filter:=stOpenFilter;
  actFileOpen.Dialog.FilterIndex:=3;
end;

//Диалоги: Открытие файла
{ TODO -cOpenFile : Здесь предусмотреть реакцию на открытие Проекта, Текста... }
procedure TfmMain.actFileOpenAccept(Sender: TObject);
begin
  CurrentPath:=ExtractFilePath(actFileOpen.Dialog.FileName);
  if ExtractFileExt(actFileOpen.Dialog.FileName)='.zxp' then begin
    { TODO -cOpenProject : Здесь дб открытие проекта }
  end
  else begin //*.a80;*.asm;*.inc;*.key;*.zxp;*.txt
    if (ExtractFileExt(actFileOpen.Dialog.FileName)='.a80')
    or (ExtractFileExt(actFileOpen.Dialog.FileName)='.asm')
    or (ExtractFileExt(actFileOpen.Dialog.FileName)='.inc')
    or (ExtractFileExt(actFileOpen.Dialog.FileName)='.key')
    then AddFile(actFileOpen.Dialog.FileName,'CP866',false)
    else AddFile(actFileOpen.Dialog.FileName,'',false);
  end;
end;

//Диалоги: Подготовка диалога открытия проекта
procedure TfmMain.actFileOpenProjectBeforeExecute(Sender: TObject);
var
  Path: String;
begin
  Path:=Options.ProjectsPath;
  if Path='' then Path:=ExtractFilePath(Application.ExeName);
  actFileOpen.Dialog.Title:=stOpenProjectTitle;
  actFileOpen.Dialog.InitialDir:=Path;
  actFileOpen.Dialog.Filter:=stOpenProjectFilter;
end;

//Operations: Сохранение текущего файла
procedure TfmMain.actSaveExecute(Sender: TObject);
begin
  //SaveFile(Editors.GetFileByTab(tabsEditor.TabIndex));
end;

//Operatons: Сохранение всех открытых файлов
procedure TfmMain.actSaveAllExecute(Sender: TObject);
var
  i: Integer;
begin
  {for i:=0 to Editors.Count-1 do begin
    if Editors.Items[i].Editor.Strings.Modified then SaveFile(i);
  end;}
end;

//Operatons: Сохранеие файла по номеру
function TfmMain.SaveFile(Index: Integer): Integer;
var
  data: TATTabData;
  i: Integer;
begin
  {Result:=-1;
  i:=0;
  if Editors.Items[Index].FirstSaveFlag then begin
    dialogSave.InitialDir:=Editors.Items[Index].FilePath;
    dialogSave.FileName:=Editors.Items[Index].FileName;
    if not dialogSave.Execute then exit;
    Editors.Items[Index].FilePath:=ExtractFilePath(dialogSave.FileName);
    if ExtractFileExt(dialogSave.FileName)='' then
      Editors.Items[Index].FileName:=ExtractFileName(dialogSave.FileName)+
      ExtractFileExt(Editors.Items[Index].FileName)
    else Editors.Items[Index].FileName:=ExtractFileName(dialogSave.FileName);
    if Pos(Editors.Items[Index].TabName,Editors.Items[Index].FileName)=0
    then Editors.Items[Index].TabName:=Editors.GetTabName(Editors.Items[Index].FileName,i);
  end;
  Editors.Items[Index].Editor.SaveToFile(Editors.Items[Index].FilePath+Editors.Items[Index].FileName);
  Editors.Items[Index].FirstSaveFlag:=false;
  data:=tabsEditor.GetTabData(Editors.Items[Index].RealTabNumber);
  data.TabColor:=clNone;
  data.TabModified:=false;
  tabsEditor.Invalidate;
  Result:=0; }
end;

//Operatons: Добавление нового файла: Добавляется страница, редактор, таб;
//Флаг AfterCurrent указывает на то, что вкладка будет создана рядом с текущей
procedure TfmMain.AddFile(FileName: string; CP: String = '';FileNew: Boolean = true; AfterCurrent: Boolean = false);
begin
 { Editors.Add(panEditor, tvCode, FileName);
  Editors.Items[Editors.Count-1].Editor.OnChange:=@EditorsOnChange;
  if not FileNew then begin
    if CP='' then Editors.Items[Editors.Count-1].Editor.Strings.EncodingDetect:=true
    else begin
      Editors.Items[Editors.Count-1].Editor.Strings.Encoding:=cEncAnsi;
      Editors.Items[Editors.Count-1].Editor.Strings.EncodingDetect:=false;
      Editors.Items[Editors.Count-1].Editor.Strings.EncodingCodepage:=CP;
    end;
    Editors.Items[Editors.Count-1].Editor.Strings.LoadFromFile(FileName);
    Editors.Items[Editors.Count-1].Editor.Modified:=false;
  end;
  if Options.NewTabAfterCurrent or AfterCurrent then
    tabsEditor.AddTab(tabsEditor.TabIndex+1,Editors.Items[Editors.Index].TabName)
  else tabsEditor.AddTab(-1,Editors.Items[Editors.Index].TabName);
  tabsEditor.TabIndex:=tabsEditor.TabCount-1;
  EditorsOnChange(Editors.Items[Editors.Count-1].Editor);   }
end;

//Tabs: реакция на модификацию файла
{ TODO -cModifyDetect : Проверять модификацию файла, отображать ее на вкладке, сбрасывать по сохранению }
procedure TfmMain.EditorsOnChange(Sender: TObject);
var
  data: TATTabData;
begin
 { if Editors.Items[Editors.Index].Editor.Modified then begin
    data:=tabsEditor.GetTabData(Editors.Items[Editors.Index].RealTabNumber);
    data.TabColor:=clRed;
    data.TabModified:=true;
    tabsEditor.Invalidate;
  end;    }
end;

//Tabs: При клике на Табе вызывем страницу по реальному номеру таба (по привязке к редактору)
procedure TfmMain.TabClickEvent(A: TObject);
var
  itemName: String;
  item: TMenuItem;
begin
  {Editors.Index:=Editors.GetFileByTab((A as TATTabs).TabIndex);
  AdapterParseDone(Editors.Items[Editors.Index].Adapter);
  //Меняем пункты меню в зависимости от состояния Лексера иекущей вкладки
  itemName:=Editors.LexerName;
  if itemName<>'' then begin
    item:=mnuViewLexerChange.Find(itemName);
    if item<>nil then item.Checked:=true;
  end;
  actLexerLexer.Checked:=Editors.LexerStatus;}
end;

//Tabs: При перетаскивании Табов сохраняем их Реальные номера (привязка к Редакторам и страницам)
procedure TfmMain.TabMoveEvent(Sender: TObject; NFrom, NTo: Integer);
var
  tp: Integer;
  i: Integer;
  //tpstr: String;
begin {
  if NTo=NFrom then exit;//Номера вкладок не меняются
  if NFrom=-1 then begin//Вставка новой вкладки
    for i:=0 to Editors.Count-1 do if Editors.Items[i].RealTabNumber>=NTo then Inc(Editors.Items[i].RealTabNumber);
    Editors.Items[Editors.Count-1].RealTabNumber:=NTo;
  end
  else if NTo=-1 then begin//Удаление
    for i:=0 to Editors.Count-1 do if Editors.Items[i].RealTabNumber>=NFrom then Dec(Editors.Items[i].RealTabNumber);
  end
  else if NTo<NFrom then begin//Перетаскивание назад
    tp:=Editors.GetFileByTab(NFrom);
    for i:=0 to Editors.Count-1 do
      if (Editors.Items[i].RealTabNumber>=NTo)
      and (Editors.Items[i].RealTabNumber<NFrom)
      then Inc(Editors.Items[i].RealTabNumber);
    Editors.Items[tp].RealTabNumber:=NTo;
  end
  else begin//Перетаскивание вперед
    tp:=Editors.GetFileByTab(NFrom);
    for i:=0 to Editors.Count-1 do
      if (Editors.Items[i].RealTabNumber>NFrom)
      and (Editors.Items[i].RealTabNumber<=NTo)
      then Dec(Editors.Items[i].RealTabNumber);
    Editors.Items[tp].RealTabNumber:=NTo;
  end;
  //tpstr:='';
  //for i:=0 to Editors.Count-1 do tpstr:=tpstr+'Файл №'+IntToStr(i)+'->'+IntToStr(Editors.Items[i].RealTabNumber)+' ';
  //sbStatus.SimpleText:=Format('Order: %sCount: %d',[tpstr,Editors.Count]);   }
end;

//Tabs: Добавление новой вкладки (вкладка, панель, редактор)
procedure TfmMain.TabPlusClickEvent(Sender: TObject);
var
  filePath: String;
begin
  if Flags.ProjectMode then filePath:=ProjectPath else filePath:=CurrentPath;
  if Options.NewTabAfterCurrent then AddFile(filePath+'noname.a80','CP866',true, true)
  else AddFile(filePath+'noname.a80','CP866');
end;

//Tabs: Закрытие файла (Таба, редактора, страницы)
procedure TfmMain.TabCloseEvent(Sender: TObject; ATabIndex: Integer;
  var ACanClose, ACanContinue: boolean);
var
  tabCaption: String;
  data: TATTabData;
  keyClose: Integer;
  EditorIndex: Integer;
begin
 { ACanClose:=false;
  data:=(Sender as TATTabs).GetTabData(ATabIndex);
  if Assigned(data) then tabCaption:= data.TabCaption else tabCaption:= '';
  keyClose:=MessageDlg(Format(stDlgCloseFile,[tabCaption]), mtWarning, mbYesNoCancel,0);
  if keyClose<>mrYes then exit;
  //Проверка на сохраненность файла
  EditorIndex:=Editors.GetFileByTab(ATabIndex);
  keyClose:=mrNo;
  if Editors.Items[EditorIndex].Editor.Modified then
    keyClose:=MessageDlg(Format(stDlgFileNotSaved,[tabCaption]), mtWarning, mbYesNoCancel,0);
  case keyClose of
    mrCancel: exit;
    mrYes: begin SaveFile(EditorIndex);
    end;
  end;
  Editors.Delete(EditorIndex);//уничтожение едитора
  ACanClose:=true; }
end;

//Settings: Считывание настроек (сохранение дефолтных, при отсутствии файла настроек)
procedure TfmMain.ReadSettings;
var
  IniFile: TIniFile;
begin
  IniFile:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  //Paths
  Options.SaveCurrentPath           :=IniFile.ReadBool('Paths','SaveCurrentPath',true);
  Options.CurrentPath               :=IniFile.ReadString('Paths','CurrentPath',ExtractFilePath(Application.ExeName));
  Options.ProjectsPath              :=IniFile.ReadString('Paths','ProjectsPath',ExtractFilePath(Application.ExeName));

  //Tabs
  Options.NewTabAfterCurrent        :=IniFile.ReadBool('Tabs','NewTabAfterCurrent',false);

  //View
  Options.ShowToolBar               :=IniFile.ReadBool('View','ShowToolBar',true);
  Options.ShowLeftPanel             :=IniFile.ReadBool('View','ShowLeftPanel',true);
  Options.ShowRightPanel            :=IniFile.ReadBool('View','ShowRightPanel',false);
  Options.ShowBottomPanel           :=IniFile.ReadBool('View','ShowBottomPanel',false);
  Options.ShowStatus                :=IniFile.ReadBool('View','ShowStatus',true);

  //Editor Options
  //General
  Options.OptShowCurLine            :=IniFile.ReadBool('Editor','OptShowCurLine',true);
  Options.OptShowCurLineMinimal     :=IniFile.ReadBool('Editor','OptShowCurLineMinimal',false);
  Options.OptShowCurColumn          :=IniFile.ReadBool('Editor','OptShowCurColumn',true);
  Options.OptLastLineOnTop          :=IniFile.ReadBool('Editor','OptLastLineOnTop',true);
  Options.OptShowFullSel            :=IniFile.ReadBool('Editor','OptShowFullSel',true);
  Options.OptShowFullHilite         :=IniFile.ReadBool('Editor','OptShowFullHilite',true);
  Options.OptShowIndentLines        :=IniFile.ReadBool('Editor','OptShowIndentLines',true);
  Options.OptShowScrollHint         :=IniFile.ReadBool('Editor','OptShowScrollHint',true);
  Options.OptTextHint               :=IniFile.ReadString('Editor','OptTextHint','Write your code here...');
  Options.OptWordChars              :=IniFile.ReadString('Editor','OptWordChars','');
  Options.OptOverwriteAllowedOnPaste:=IniFile.ReadBool('Editor','OptOverwriteAllowedOnPaste',true);
  Options.OptCopyLinesIfNoSel       :=IniFile.ReadBool('Editor','OptCopyLinesIfNoSel',false);
  Options.OptCutLinesIfNoSel        :=IniFile.ReadBool('Editor','OptCutLinesIfNoSel',false);
  Options.OptSavingTrimSpaces       :=IniFile.ReadBool('Editor','OptSavingTrimSpaces',true);
  Options.OptSavingForceFinalEol    :=IniFile.ReadBool('Editor','OptSavingForceFinalEol',true);
  //Gutter
  Options.OptNumbersStyle           :=IniFile.ReadInteger('Editor','OptNumbersStyle',0);
  Options.OptNumbersAlignment       :=IniFile.ReadInteger('Editor','OptNumbersAlignment',1);
  Options.OptNumbersShowFirst       :=IniFile.ReadBool('Editor','OptNumbersShowFirst',true);
  Options.OptNumbersSkippedChar     :=IniFile.ReadString('Editor','OptNumbersSkippedChar','.');
  Options.OptNumbersShowCarets      :=IniFile.ReadBool('Editor','OptNumbersShowCarets',true);
  Options.OptShowGutterCaretBG      :=IniFile.ReadBool('Editor','OptShowGutterCaretBG',true);
  Options.OptNumbersFontSize        :=IniFile.ReadInteger('Editor','OptNumbersFontSize',0);
  Options.OptGutterShowFoldAlways   :=IniFile.ReadBool('Editor','OptGutterShowFoldAlways',true);
  Options.OptGutterShowFoldLines    :=IniFile.ReadBool('Editor','OptGutterShowFoldLines',true);
  Options.OptGutterShowFoldLinesAll :=IniFile.ReadBool('Editor','OptGutterShowFoldLinesAll',true);
  Options.OptGutterPlusSize         :=IniFile.ReadInteger('Editor','OptGutterPlusSize',4);
  Options.OptRulerSize              :=IniFile.ReadInteger('Editor','OptRulerSize',20);
  Options.OptRulerFontSize          :=IniFile.ReadInteger('Editor','OptRulerFontSize',8);
  Options.OptRulerTextIndent        :=IniFile.ReadInteger('Editor','OptRulerTextIndent',0);
  //Unprintable
  Options.OptUnprintedVisible        :=IniFile.ReadBool('Editor','OptUnprintedVisible',false);
  Options.OptUnprintedSpaces         :=IniFile.ReadBool('Editor','OptUnprintedSpaces',true);
  Options.OptUnprintedEnds           :=IniFile.ReadBool('Editor','OptUnprintedEnds',true);
  Options.OptUnprintedEndsDetails    :=IniFile.ReadBool('Editor','OptUnprintedEndsDetails',true);

  //Colors
  Options.BlockSepLine      :=StringToColor(IniFile.ReadString('EditorColors','BlockSepLine'      ,'clMedGray'      ));
  Options.BlockStaple       :=StringToColor(IniFile.ReadString('EditorColors','BlockStaple'       ,'clMedGray'      ));
  Options.BookmarkBG        :=StringToColor(IniFile.ReadString('EditorColors','BookmarkBG'        ,'clMoneyGreen'   ));
  Options.BorderLine        :=StringToColor(IniFile.ReadString('EditorColors','BorderLine'        ,'clMedGray'      ));
  Options.Caret             :=StringToColor(IniFile.ReadString('EditorColors','Caret'             ,'clBlack'        ));
  Options.CollapseLine      :=StringToColor(IniFile.ReadString('EditorColors','CollapseLine'      ,'$00A06060'      ));
  Options.CollapseMarkBG    :=StringToColor(IniFile.ReadString('EditorColors','CollapseMarkBG'    ,'clCream'        ));
  Options.CollapseMarkBorder:=StringToColor(IniFile.ReadString('EditorColors','CollapseMarkBorder','$00E08080'      ));
  Options.CollapseMarkFont  :=StringToColor(IniFile.ReadString('EditorColors','CollapseMarkFont'  ,'$00E08080'      ));
  Options.ComboboxArrow     :=StringToColor(IniFile.ReadString('EditorColors','ComboboxArrow'     ,'clGray'         ));
  Options.ComboboxArrowBG   :=StringToColor(IniFile.ReadString('EditorColors','ComboboxArrowBG'   ,'$00F0F0F0'      ));
  Options.CurrentLineBG     :=StringToColor(IniFile.ReadString('EditorColors','CurrentLineBG'     ,'$00E0F0F0'      ));
  Options.GutterBG          :=StringToColor(IniFile.ReadString('EditorColors','GutterBG'          ,'$00E0E0E0'      ));
  Options.GutterCaretBG     :=StringToColor(IniFile.ReadString('EditorColors','GutterCaretBG'     ,'$00C8C8C8'      ));
  Options.GutterCaretFont   :=StringToColor(IniFile.ReadString('EditorColors','GutterCaretFont'   ,'clGray'         ));
  Options.GutterFoldBG      :=StringToColor(IniFile.ReadString('EditorColors','GutterFoldBG'      ,'$00C8C8C8'      ));
  Options.GutterFoldLine    :=StringToColor(IniFile.ReadString('EditorColors','GutterFoldLine'    ,'clGray'         ));
  Options.GutterFont        :=StringToColor(IniFile.ReadString('EditorColors','GutterFont'        ,'clGray'         ));
  Options.GutterPlusBG      :=StringToColor(IniFile.ReadString('EditorColors','GutterPlusBG'      ,'$00F4F4F4'      ));
  Options.GutterPlusBorder  :=StringToColor(IniFile.ReadString('EditorColors','GutterPlusBorder'  ,'clGray'         ));
  Options.GutterSeparatorBG :=StringToColor(IniFile.ReadString('EditorColors','GutterSeparatorBG' ,'clBlack'        ));
  Options.IndentVertLines   :=StringToColor(IniFile.ReadString('EditorColors','IndentVertLines'   ,'clMedGray'      ));
  Options.Links             :=StringToColor(IniFile.ReadString('EditorColors','Links'             ,'clBlue'         ));
  Options.LockedBG          :=StringToColor(IniFile.ReadString('EditorColors','LockedBG'          ,'$00E0E0E0'      ));
  Options.MarginCaret       :=StringToColor(IniFile.ReadString('EditorColors','MarginCaret'       ,'clLime'         ));
  Options.MarginRight       :=StringToColor(IniFile.ReadString('EditorColors','MarginRight'       ,'clSilver'       ));
  Options.MarginUser        :=StringToColor(IniFile.ReadString('EditorColors','MarginUser'        ,'clYellow'       ));
  Options.MarkedLinesBG     :=StringToColor(IniFile.ReadString('EditorColors','MarkedLinesBG'     ,'$00F0E0B0'      ));
  Options.Markers           :=StringToColor(IniFile.ReadString('EditorColors','Markers'           ,'$000000C0'      ));
  Options.MinimapBorder     :=StringToColor(IniFile.ReadString('EditorColors','MinimapBorder'     ,'clSilver'       ));
  Options.MinimapSelBG      :=StringToColor(IniFile.ReadString('EditorColors','MinimapSelBG'      ,'$00EEEEEE'      ));
  Options.RulerBG           :=StringToColor(IniFile.ReadString('EditorColors','RulerBG'           ,'$00E0E0E0'      ));
  Options.RulerFont         :=StringToColor(IniFile.ReadString('EditorColors','RulerFont'         ,'clGray'         ));
  Options.StateAdded        :=StringToColor(IniFile.ReadString('EditorColors','StateAdded'        ,'$0020C020'      ));
  Options.StateChanged      :=StringToColor(IniFile.ReadString('EditorColors','StateChanged'      ,'$0000F0F0'      ));
  Options.StateSaved        :=StringToColor(IniFile.ReadString('EditorColors','StateSaved'        ,'clMedGray'      ));
  Options.TextBG            :=StringToColor(IniFile.ReadString('EditorColors','TextBG'            ,'clWhite'        ));
  Options.TextDisabledBG    :=StringToColor(IniFile.ReadString('EditorColors','TextDisabledBG'    ,'$00F0F0F0'      ));
  Options.TextDisabledFont  :=StringToColor(IniFile.ReadString('EditorColors','TextDisabledFont'  ,'clGray'         ));
  Options.TextFont          :=StringToColor(IniFile.ReadString('EditorColors','TextFont'          ,'clBlack'        ));
  Options.TextHintFont      :=StringToColor(IniFile.ReadString('EditorColors','TextHintFont'      ,'clGray'         ));
  Options.TextSelBG         :=StringToColor(IniFile.ReadString('EditorColors','TextSelBG'         ,'clHighlight'    ));
  Options.TextSelFont       :=StringToColor(IniFile.ReadString('EditorColors','TextSelFont'       ,'clHighlightText'));
  Options.UnprintedBG       :=StringToColor(IniFile.ReadString('EditorColors','UnprintedBG'       ,'$00E0E0E0'      ));
  Options.UnprintedFont     :=StringToColor(IniFile.ReadString('EditorColors','UnprintedFont'     ,'$005050F0'      ));
  Options.UnprintedHexFont  :=StringToColor(IniFile.ReadString('EditorColors','UnprintedHexFont'  ,'clMedGray'      ));

  IniFile.Free;
  if not FileExists(ChangeFileExt(Application.ExeName,'.ini')) then WriteSettings;
end;

//Settings: Сохранение настроек
procedure TfmMain.WriteSettings;
var
  IniFile: TIniFile;
begin
  IniFile:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  //Paths
  IniFile.WriteBool('Paths','SaveCurrentPath',Options.SaveCurrentPath);
  IniFile.WriteString('Paths','CurrentPath',Options.CurrentPath);
  IniFile.WriteString('Paths','ProjectsPath',Options.ProjectsPath);
  //Tabs
  IniFile.WriteBool('Tabs','NewTabAfterCurrent',Options.NewTabAfterCurrent);
  //View
  IniFile.WriteBool('View','ShowToolBar',Options.ShowToolBar);
  IniFile.WriteBool('View','ShowLeftPanel',Options.ShowLeftPanel);
  IniFile.WriteBool('View','ShowRightPanel',Options.ShowRightPanel);
  IniFile.WriteBool('View','ShowBottomPanel',Options.ShowBottomPanel);
  IniFile.WriteBool('View','ShowStatus',Options.ShowStatus);
  //General
  IniFile.WriteBool('Editor','OptShowCurLine',            Options.OptShowCurLine);
  IniFile.WriteBool('Editor','OptShowCurLineMinimal',     Options.OptShowCurLineMinimal);
  IniFile.WriteBool('Editor','OptShowCurColumn',          Options.OptShowCurColumn);
  IniFile.WriteBool('Editor','OptLastLineOnTop',          Options.OptLastLineOnTop);
  IniFile.WriteBool('Editor','OptShowFullSel',            Options.OptShowFullSel);
  IniFile.WriteBool('Editor','OptShowFullHilite',         Options.OptShowFullHilite);
  IniFile.WriteBool('Editor','OptShowIndentLines',        Options.OptShowIndentLines);
  IniFile.WriteBool('Editor','OptShowScrollHint',         Options.OptShowScrollHint);
  IniFile.WriteString('Editor','OptTextHint',             Options.OptTextHint);
  IniFile.WriteString('Editor','OptWordChars',            Options.OptWordChars);
  IniFile.WriteBool('Editor','OptOverwriteAllowedOnPaste',Options.OptOverwriteAllowedOnPaste);
  IniFile.WriteBool('Editor','OptCopyLinesIfNoSel',       Options.OptCopyLinesIfNoSel);
  IniFile.WriteBool('Editor','OptCutLinesIfNoSel',        Options.OptCutLinesIfNoSel);
  IniFile.WriteBool('Editor','OptSavingTrimSpaces',       Options.OptSavingTrimSpaces);
  IniFile.WriteBool('Editor','OptSavingForceFinalEol',    Options.OptSavingForceFinalEol);
  //Gutter
  IniFile.WriteInteger('Editor','OptNumbersStyle',        Options.OptNumbersStyle);
  IniFile.WriteInteger('Editor','OptNumbersAlignment',    Options.OptNumbersAlignment);
  IniFile.WriteBool('Editor','OptNumbersShowFirst',       Options.OptNumbersShowFirst);
  IniFile.WriteString('Editor','OptNumbersSkippedChar',   Options.OptNumbersSkippedChar);
  IniFile.WriteBool('Editor','OptNumbersShowCarets',      Options.OptNumbersShowCarets);
  IniFile.WriteBool('Editor','OptShowGutterCaretBG',      Options.OptShowGutterCaretBG);
  IniFile.WriteInteger('Editor','OptNumbersFontSize',     Options.OptNumbersFontSize);
  IniFile.WriteBool('Editor','OptGutterShowFoldAlways',   Options.OptGutterShowFoldAlways);
  IniFile.WriteBool('Editor','OptGutterShowFoldLines',    Options.OptGutterShowFoldLines);
  IniFile.WriteBool('Editor','OptGutterShowFoldLinesAll', Options.OptGutterShowFoldLinesAll);
  IniFile.WriteInteger('Editor','OptGutterPlusSize',      Options.OptGutterPlusSize);
  IniFile.WriteInteger('Editor','OptRulerSize',           Options.OptRulerSize);
  IniFile.WriteInteger('Editor','OptRulerFontSize',       Options.OptRulerFontSize);
  IniFile.WriteInteger('Editor','OptRulerTextIndent',     Options.OptRulerTextIndent);
  //Unprintable
  IniFile.WriteBool('Editor','OptUnprintedVisible',           Options.OptUnprintedVisible);
  IniFile.WriteBool('Editor','OptUnprintedSpaces',            Options.OptUnprintedSpaces);
  IniFile.WriteBool('Editor','OptUnprintedEnds',              Options.OptUnprintedEnds);
  IniFile.WriteBool('Editor','OptUnprintedEndsDetails',       Options.OptUnprintedEndsDetails);
  //Colors
  IniFile.WriteString('EditorColors','BlockSepLine'      ,ColorToString(Options.BlockSepLine      ));
  IniFile.WriteString('EditorColors','BlockStaple'       ,ColorToString(Options.BlockStaple       ));
  IniFile.WriteString('EditorColors','BookmarkBG'        ,ColorToString(Options.BookmarkBG        ));
  IniFile.WriteString('EditorColors','BorderLine'        ,ColorToString(Options.BorderLine        ));
  IniFile.WriteString('EditorColors','Caret'             ,ColorToString(Options.Caret             ));
  IniFile.WriteString('EditorColors','CollapseLine'      ,ColorToString(Options.CollapseLine      ));
  IniFile.WriteString('EditorColors','CollapseMarkBG'    ,ColorToString(Options.CollapseMarkBG    ));
  IniFile.WriteString('EditorColors','CollapseMarkBorder',ColorToString(Options.CollapseMarkBorder));
  IniFile.WriteString('EditorColors','CollapseMarkFont'  ,ColorToString(Options.CollapseMarkFont  ));
  IniFile.WriteString('EditorColors','ComboboxArrow'     ,ColorToString(Options.ComboboxArrow     ));
  IniFile.WriteString('EditorColors','ComboboxArrowBG'   ,ColorToString(Options.ComboboxArrowBG   ));
  IniFile.WriteString('EditorColors','CurrentLineBG'     ,ColorToString(Options.CurrentLineBG     ));
  IniFile.WriteString('EditorColors','GutterBG'          ,ColorToString(Options.GutterBG          ));
  IniFile.WriteString('EditorColors','GutterCaretBG'     ,ColorToString(Options.GutterCaretBG     ));
  IniFile.WriteString('EditorColors','GutterCaretFont'   ,ColorToString(Options.GutterCaretFont   ));
  IniFile.WriteString('EditorColors','GutterFoldBG'      ,ColorToString(Options.GutterFoldBG      ));
  IniFile.WriteString('EditorColors','GutterFoldLine'    ,ColorToString(Options.GutterFoldLine    ));
  IniFile.WriteString('EditorColors','GutterFont'        ,ColorToString(Options.GutterFont        ));
  IniFile.WriteString('EditorColors','GutterPlusBG'      ,ColorToString(Options.GutterPlusBG      ));
  IniFile.WriteString('EditorColors','GutterPlusBorder'  ,ColorToString(Options.GutterPlusBorder  ));
  IniFile.WriteString('EditorColors','GutterSeparatorBG' ,ColorToString(Options.GutterSeparatorBG ));
  IniFile.WriteString('EditorColors','IndentVertLines'   ,ColorToString(Options.IndentVertLines   ));
  IniFile.WriteString('EditorColors','Links'             ,ColorToString(Options.Links             ));
  IniFile.WriteString('EditorColors','LockedBG'          ,ColorToString(Options.LockedBG          ));
  IniFile.WriteString('EditorColors','MarginCaret'       ,ColorToString(Options.MarginCaret       ));
  IniFile.WriteString('EditorColors','MarginRight'       ,ColorToString(Options.MarginRight       ));
  IniFile.WriteString('EditorColors','MarginUser'        ,ColorToString(Options.MarginUser        ));
  IniFile.WriteString('EditorColors','MarkedLinesBG'     ,ColorToString(Options.MarkedLinesBG     ));
  IniFile.WriteString('EditorColors','Markers'           ,ColorToString(Options.Markers           ));
  IniFile.WriteString('EditorColors','MinimapBorder'     ,ColorToString(Options.MinimapBorder     ));
  IniFile.WriteString('EditorColors','MinimapSelBG'      ,ColorToString(Options.MinimapSelBG      ));
  IniFile.WriteString('EditorColors','RulerBG'           ,ColorToString(Options.RulerBG           ));
  IniFile.WriteString('EditorColors','RulerFont'         ,ColorToString(Options.RulerFont         ));
  IniFile.WriteString('EditorColors','StateAdded'        ,ColorToString(Options.StateAdded        ));
  IniFile.WriteString('EditorColors','StateChanged'      ,ColorToString(Options.StateChanged      ));
  IniFile.WriteString('EditorColors','StateSaved'        ,ColorToString(Options.StateSaved        ));
  IniFile.WriteString('EditorColors','TextBG'            ,ColorToString(Options.TextBG            ));
  IniFile.WriteString('EditorColors','TextDisabledBG'    ,ColorToString(Options.TextDisabledBG    ));
  IniFile.WriteString('EditorColors','TextDisabledFont'  ,ColorToString(Options.TextDisabledFont  ));
  IniFile.WriteString('EditorColors','TextFont'          ,ColorToString(Options.TextFont          ));
  IniFile.WriteString('EditorColors','TextHintFont'      ,ColorToString(Options.TextHintFont      ));
  IniFile.WriteString('EditorColors','TextSelBG'         ,ColorToString(Options.TextSelBG         ));
  IniFile.WriteString('EditorColors','TextSelFont'       ,ColorToString(Options.TextSelFont       ));
  IniFile.WriteString('EditorColors','UnprintedBG'       ,ColorToString(Options.UnprintedBG       ));
  IniFile.WriteString('EditorColors','UnprintedFont'     ,ColorToString(Options.UnprintedFont     ));
  IniFile.WriteString('EditorColors','UnprintedHexFont'  ,ColorToString(Options.UnprintedHexFont  ));

  IniFile.Free
end;

//Setting: Диалог настроек
//Считываем настройки из текущих и открываем диалог настроек, при успешном завершении
//диалога, применяем и сохраняем настройки
{ TODO -cSettings : Доделать настройки }
procedure TfmMain.actOptionsSettingsExecute(Sender: TObject);
var
  fmSettings: TfmSettings;
begin
  fmSettings:=TfmSettings.Create(Self);
  {
  //Paths
  SaveCurrentPath: Boolean;
  CurrentPath: String;
  ProjectsPath: String;
  //Tabs
  NewTabAfterCurrent
  //View
  ShowToolBar: Boolean;
  ShowLeftPanel: Boolean;
  ShowRightPanel: Boolean;
  ShowBottomPanel: Boolean;
  ShowStatus: Boolean;
  }
  //Editor Options
  //General
  fmSettings.chkOptShowCurLine.Checked            :=Options.OptShowCurLine;
  fmSettings.chkOptShowCurLineMinimal.Checked     :=Options.OptShowCurLineMinimal;
  fmSettings.chkOptShowCurColumn.Checked          :=Options.OptShowCurColumn;
  fmSettings.chkOptLastLineOnTop.Checked          :=Options.OptLastLineOnTop;
  fmSettings.chkOptShowFullSel.Checked            :=Options.OptShowFullSel;
  fmSettings.chkOptShowFullHilite.Checked         :=Options.OptShowFullHilite;
  fmSettings.chkOptShowIndentLines.Checked        :=Options.OptShowIndentLines;
  fmSettings.chkOptShowScrollHint.Checked         :=Options.OptShowScrollHint;
  fmSettings.edOptTextHint.Text                   :=Options.OptTextHint;
  fmSettings.edOptWordChars.Text                  :=Options.OptWordChars;
  fmSettings.chkOptOverwriteAllowedOnPaste.Checked:=Options.OptOverwriteAllowedOnPaste;
  fmSettings.chkOptCopyLinesIfNoSel.Checked       :=Options.OptCopyLinesIfNoSel;
  fmSettings.chkOptCutLinesIfNoSel.Checked        :=Options.OptCutLinesIfNoSel;
  fmSettings.chkOptSavingTrimSpaces.Checked       :=Options.OptSavingTrimSpaces;
  fmSettings.chkOptSavingForceFinalEol.Checked    :=Options.OptSavingForceFinalEol;
  //Gutter
  fmSettings.comboOptNumbersStyle.ItemIndex       :=Options.OptNumbersStyle;
  fmSettings.comboOptNumbersAlignment.ItemIndex   :=Options.OptNumbersAlignment;
  fmSettings.chkOptNumbersShowFirst.Checked       :=Options.OptNumbersShowFirst;
  fmSettings.edOptNumbersSkippedChar.Text         :=Options.OptNumbersSkippedChar;
  fmSettings.chkOptNumbersShowCarets.Checked      :=Options.OptNumbersShowCarets;
  fmSettings.chkOptShowGutterCaretBG.Checked      :=Options.OptShowGutterCaretBG;
  fmSettings.edOptNumbersFontSize.Value           :=Options.OptNumbersFontSize;
  fmSettings.chkOptGutterShowFoldAlways.Checked   :=Options.OptGutterShowFoldAlways;
  fmSettings.chkOptGutterShowFoldLines.Checked    :=Options.OptGutterShowFoldLines;
  fmSettings.chkOptGutterShowFoldLinesAll.Checked :=Options.OptGutterShowFoldLinesAll;
  fmSettings.edOptGutterPlusSize.Value            :=Options.OptGutterPlusSize;
  fmSettings.edOptRulerSize.Value                 :=Options.OptRulerSize;
  fmSettings.edOptRulerFontSize.Value             :=Options.OptRulerFontSize;
  fmSettings.edOptRulerTextIndent.Value           :=Options.OptRulerTextIndent;
  //Unprintable
  fmSettings.chkOptUnprintedVisible.Checked       := Options.OptUnprintedVisible;
  fmSettings.chkOptUnprintedSpaces.Checked        := Options.OptUnprintedSpaces;
  fmSettings.chkOptUnprintedEnds.Checked          := Options.OptUnprintedEnds;
  fmSettings.chkOptUnprintedEndsDetails.Checked   := Options.OptUnprintedEndsDetails;
  //Colors
  fmSettings.colorBlockSepLine.Selected      :=Options.BlockSepLine      ;
  fmSettings.colorBlockStaple.Selected       :=Options.BlockStaple       ;
  fmSettings.colorBookmarkBG.Selected        :=Options.BookmarkBG        ;
  fmSettings.colorBorderLine.Selected        :=Options.BorderLine        ;
  fmSettings.colorCaret.Selected             :=Options.Caret             ;
  fmSettings.colorCollapseLine.Selected      :=Options.CollapseLine      ;
  fmSettings.colorCollapseMarkBG.Selected    :=Options.CollapseMarkBG    ;
  fmSettings.colorCollapseMarkBorder.Selected:=Options.CollapseMarkBorder;
  fmSettings.colorCollapseMarkFont.Selected  :=Options.CollapseMarkFont  ;
  fmSettings.colorComboboxArrow.Selected     :=Options.ComboboxArrow     ;
  fmSettings.colorComboboxArrowBG.Selected   :=Options.ComboboxArrowBG   ;
  fmSettings.colorCurrentLineBG.Selected     :=Options.CurrentLineBG     ;
  fmSettings.colorGutterBG.Selected          :=Options.GutterBG          ;
  fmSettings.colorGutterCaretBG.Selected     :=Options.GutterCaretBG     ;
  fmSettings.colorGutterCaretFont.Selected   :=Options.GutterCaretFont   ;
  fmSettings.colorGutterFoldBG.Selected      :=Options.GutterFoldBG      ;
  fmSettings.colorGutterFoldLine.Selected    :=Options.GutterFoldLine    ;
  fmSettings.colorGutterFont.Selected        :=Options.GutterFont        ;
  fmSettings.colorGutterPlusBG.Selected      :=Options.GutterPlusBG      ;
  fmSettings.colorGutterPlusBorder.Selected  :=Options.GutterPlusBorder  ;
  fmSettings.colorGutterSeparatorBG.Selected :=Options.GutterSeparatorBG ;
  fmSettings.colorIndentVertLines.Selected   :=Options.IndentVertLines   ;
  fmSettings.colorLinks.Selected             :=Options.Links             ;
  fmSettings.colorLockedBG.Selected          :=Options.LockedBG          ;
  fmSettings.colorMarginCaret.Selected       :=Options.MarginCaret       ;
  fmSettings.colorMarginRight.Selected       :=Options.MarginRight       ;
  fmSettings.colorMarginUser.Selected        :=Options.MarginUser        ;
  fmSettings.colorMarkedLinesBG.Selected     :=Options.MarkedLinesBG     ;
  fmSettings.colorMarkers.Selected           :=Options.Markers           ;
  fmSettings.colorMinimapBorder.Selected     :=Options.MinimapBorder     ;
  fmSettings.colorMinimapSelBG.Selected      :=Options.MinimapSelBG      ;
  fmSettings.colorRulerBG.Selected           :=Options.RulerBG           ;
  fmSettings.colorRulerFont.Selected         :=Options.RulerFont         ;
  fmSettings.colorStateAdded.Selected        :=Options.StateAdded        ;
  fmSettings.colorStateChanged.Selected      :=Options.StateChanged      ;
  fmSettings.colorStateSaved.Selected        :=Options.StateSaved        ;
  fmSettings.colorTextBG.Selected            :=Options.TextBG            ;
  fmSettings.colorTextDisabledBG.Selected    :=Options.TextDisabledBG    ;
  fmSettings.colorTextDisabledFont.Selected  :=Options.TextDisabledFont  ;
  fmSettings.colorTextFont.Selected          :=Options.TextFont          ;
  fmSettings.colorTextHintFont.Selected      :=Options.TextHintFont      ;
  fmSettings.colorTextSelBG.Selected         :=Options.TextSelBG         ;
  fmSettings.colorTextSelFont.Selected       :=Options.TextSelFont       ;
  fmSettings.colorUnprintedBG.Selected       :=Options.UnprintedBG       ;
  fmSettings.colorUnprintedFont.Selected     :=Options.UnprintedFont     ;
  fmSettings.colorUnprintedHexFont.Selected  :=Options.UnprintedHexFont  ;
  if fmSettings.ShowModal=mrOK then begin
    {
    //Paths
    SaveCurrentPath: Boolean;
    CurrentPath: String;
    ProjectsPath: String;
    //Tabs
    NewTabAfterCurrent
    //View
    ShowToolBar: Boolean;
    ShowLeftPanel: Boolean;
    ShowRightPanel: Boolean;
    ShowBottomPanel: Boolean;
    ShowStatus: Boolean;
    }
    //General
    Options.OptShowCurLine             := fmSettings.chkOptShowCurLine.Checked;
    Options.OptShowCurLineMinimal      := fmSettings.chkOptShowCurLineMinimal.Checked;
    Options.OptShowCurColumn           := fmSettings.chkOptShowCurColumn.Checked;
    Options.OptLastLineOnTop           := fmSettings.chkOptLastLineOnTop.Checked;
    Options.OptShowFullSel             := fmSettings.chkOptShowFullSel.Checked;
    Options.OptShowFullHilite          := fmSettings.chkOptShowFullHilite.Checked;
    Options.OptShowIndentLines         := fmSettings.chkOptShowIndentLines.Checked;
    Options.OptShowScrollHint          := fmSettings.chkOptShowScrollHint.Checked;
    Options.OptTextHint                := fmSettings.edOptTextHint.Text;
    Options.OptWordChars               := fmSettings.edOptWordChars.Text;
    Options.OptOverwriteAllowedOnPaste := fmSettings.chkOptOverwriteAllowedOnPaste.Checked;
    Options.OptCopyLinesIfNoSel        := fmSettings.chkOptCopyLinesIfNoSel.Checked;
    Options.OptCutLinesIfNoSel         := fmSettings.chkOptCutLinesIfNoSel.Checked;
    Options.OptSavingTrimSpaces        := fmSettings.chkOptSavingTrimSpaces.Checked;
    Options.OptSavingForceFinalEol     := fmSettings.chkOptSavingForceFinalEol.Checked;
    //Gutter
    Options.OptNumbersStyle            := fmSettings.comboOptNumbersStyle.ItemIndex;
    Options.OptNumbersAlignment        := fmSettings.comboOptNumbersAlignment.ItemIndex;
    Options.OptNumbersShowFirst        := fmSettings.chkOptNumbersShowFirst.Checked;
    Options.OptNumbersSkippedChar      := fmSettings.edOptNumbersSkippedChar.Text;
    Options.OptNumbersShowCarets       := fmSettings.chkOptNumbersShowCarets.Checked;
    Options.OptShowGutterCaretBG       := fmSettings.chkOptShowGutterCaretBG.Checked;
    Options.OptNumbersFontSize         := fmSettings.edOptNumbersFontSize.Value;
    Options.OptGutterShowFoldAlways    := fmSettings.chkOptGutterShowFoldAlways.Checked;
    Options.OptGutterShowFoldLines     := fmSettings.chkOptGutterShowFoldLines.Checked;
    Options.OptGutterShowFoldLinesAll  := fmSettings.chkOptGutterShowFoldLinesAll.Checked;
    Options.OptGutterPlusSize          := fmSettings.edOptGutterPlusSize.Value;
    Options.OptRulerSize               := fmSettings.edOptRulerSize.Value;
    Options.OptRulerFontSize           := fmSettings.edOptRulerFontSize.Value;
    Options.OptRulerTextIndent         := fmSettings.edOptRulerTextIndent.Value;
    //Unprintable
    Options.OptUnprintedVisible        := fmSettings.chkOptUnprintedVisible.Checked;
    Options.OptUnprintedSpaces         := fmSettings.chkOptUnprintedSpaces.Checked;
    Options.OptUnprintedEnds           := fmSettings.chkOptUnprintedEnds.Checked;
    Options.OptUnprintedEndsDetails    := fmSettings.chkOptUnprintedEndsDetails.Checked;
    //Colors
    Options.BlockSepLine       := fmSettings.colorBlockSepLine.Selected;
    Options.BlockStaple        := fmSettings.colorBlockStaple.Selected;
    Options.BookmarkBG         := fmSettings.colorBookmarkBG.Selected;
    Options.BorderLine         := fmSettings.colorBorderLine.Selected;
    Options.Caret              := fmSettings.colorCaret.Selected;
    Options.CollapseLine       := fmSettings.colorCollapseLine.Selected;
    Options.CollapseMarkBG     := fmSettings.colorCollapseMarkBG.Selected;
    Options.CollapseMarkBorder := fmSettings.colorCollapseMarkBorder.Selected;
    Options.CollapseMarkFont   := fmSettings.colorCollapseMarkFont.Selected;
    Options.ComboboxArrow      := fmSettings.colorComboboxArrow.Selected;
    Options.ComboboxArrowBG    := fmSettings.colorComboboxArrowBG.Selected;
    Options.CurrentLineBG      := fmSettings.colorCurrentLineBG.Selected;
    Options.GutterBG           := fmSettings.colorGutterBG.Selected;
    Options.GutterCaretBG      := fmSettings.colorGutterCaretBG.Selected;
    Options.GutterCaretFont    := fmSettings.colorGutterCaretFont.Selected;
    Options.GutterFoldBG       := fmSettings.colorGutterFoldBG.Selected;
    Options.GutterFoldLine     := fmSettings.colorGutterFoldLine.Selected;
    Options.GutterFont         := fmSettings.colorGutterFont.Selected;
    Options.GutterPlusBG       := fmSettings.colorGutterPlusBG.Selected;
    Options.GutterPlusBorder   := fmSettings.colorGutterPlusBorder.Selected;
    Options.GutterSeparatorBG  := fmSettings.colorGutterSeparatorBG.Selected;
    Options.IndentVertLines    := fmSettings.colorIndentVertLines.Selected;
    Options.Links              := fmSettings.colorLinks.Selected;
    Options.LockedBG           := fmSettings.colorLockedBG.Selected;
    Options.MarginCaret        := fmSettings.colorMarginCaret.Selected;
    Options.MarginRight        := fmSettings.colorMarginRight.Selected;
    Options.MarginUser         := fmSettings.colorMarginUser.Selected;
    Options.MarkedLinesBG      := fmSettings.colorMarkedLinesBG.Selected;
    Options.Markers            := fmSettings.colorMarkers.Selected;
    Options.MinimapBorder      := fmSettings.colorMinimapBorder.Selected;
    Options.MinimapSelBG       := fmSettings.colorMinimapSelBG.Selected;
    Options.RulerBG            := fmSettings.colorRulerBG.Selected;
    Options.RulerFont          := fmSettings.colorRulerFont.Selected;
    Options.StateAdded         := fmSettings.colorStateAdded.Selected;
    Options.StateChanged       := fmSettings.colorStateChanged.Selected;
    Options.StateSaved         := fmSettings.colorStateSaved.Selected;
    Options.TextBG             := fmSettings.colorTextBG.Selected;
    Options.TextDisabledBG     := fmSettings.colorTextDisabledBG.Selected;
    Options.TextDisabledFont   := fmSettings.colorTextDisabledFont.Selected;
    Options.TextFont           := fmSettings.colorTextFont.Selected;
    Options.TextHintFont       := fmSettings.colorTextHintFont.Selected;
    Options.TextSelBG          := fmSettings.colorTextSelBG.Selected;
    Options.TextSelFont        := fmSettings.colorTextSelFont.Selected;
    Options.UnprintedBG        := fmSettings.colorUnprintedBG.Selected;
    Options.UnprintedFont      := fmSettings.colorUnprintedFont.Selected;
    Options.UnprintedHexFont   := fmSettings.colorUnprintedHexFont.Selected;
    WriteSettings;
    ApplySettings;
  end;

  fmSettings.Free;
end;

//Settings: Применение настроек
procedure TfmMain.ApplySettings;
var
  i: Integer;
begin
  //Устанавливаем нужные опции для всех редакторов из настроек
{  for i:=0 to Editors.Count-1 do Editors.GetSettings(i);
  Editors.Items[Editors.Index].Editor.Update;  }
end;

{Settings&Lexer: Настройки библиотеки Лексеров}
{ TODO -cLexerLib : Доделать язык, кодировку... }
procedure TfmMain.actOptionsLexersSetupExecute(Sender: TObject);
var
  dirAcp: string;
begin
  dirAcp:= ExtractFileDir(Application.ExeName)+DirectorySeparator+'acp';
  CreateDir(dirAcp);

  DoShowDialogLexerLib(SynManager, dirAcp, 'Courier new', 9);
  if SynManager.Modified then
  begin
    SynManager.Modified:= false;
    if Application.MessageBox('Lib was modified. Save file?', 'Demo',
      MB_OKCANCEL or MB_ICONQUESTION)=id_ok then
      SynManager.SaveToFile(SynManager.FileName);
  end;
end;

//Lexer: Получаем список Лексеров
procedure TfmMain.UpdateLexList;
var
  i: Integer;
begin
  for i:=0 to SynManager.AnalyzerCount-1 do LexerList.Add(SynManager.Analyzers[i].LexerName);
  LexerList.sort;
end;

//Lexer: Очистка дерева
procedure TfmMain.AdapterParseBegin(Sender: TObject);
begin
  //tvCode.Items.Clear;
end;

//Lexer: Заполнение дерева по результатам парсинга
procedure TfmMain.AdapterParseDone(Sender: TObject);
begin
  (Sender as TATAdapterEControl).TreeFill(tvCode);
  EditorChangeCaretPos(Self);
end;

//Lexer: Показывает на дереве, где находимся
procedure TfmMain.EditorChangeCaretPos(Sender: TObject);
begin
  {Editors.Items[Editors.Index].Adapter.TreeShowItemForCaret(tvCode, Point(Editors.Items[Editors.Index].Editor.Carets[0].PosX,Editors.Items[Editors.Index].Editor.Carets[0].PosY));   }
end;

//Lexer: Переход с узла дерева
procedure TfmMain.tvCodeClick(Sender: TObject);
var
  R: TecTextRange;
  P: TPoint;
begin
{  if Editors.Items[Editors.Index].Adapter.TreeBusy then exit;
  if tvCode.Selected=nil then exit;
  if tvCode.Selected.Data=nil then exit;

  R:= TecTextRange(tvCode.Selected.Data);
  P:= Editors.Items[Editors.Index].Adapter.TreeGetPositionOfRange(R);

  Editors.Items[Editors.Index].Editor.DoGotoPos_AndUnfold(P, Point(-1, -1), 5, 5);
  Editors.Items[Editors.Index].Editor.SetFocus;   }
end;

//Lexer: Комментирование выделенных строк, комментарием из Лексера
procedure TfmMain.DoCommentAct(Act: TATCommentAction);
var
  Str: string;
begin
{  Str:= GetComment;
  if Str='' then
    Showmessage('No line comment defined for lexer')
  else
    Editors.Items[Editors.Index].Editor.DoCommentSelectionLines(Act, UnicodeString(Str));   }
end;

//Lexer: Получение символа коментария из текущего Лексера
function TfmMain.GetComment: string;
var
  Analyzer: TecSyntAnalyzer;
begin
{  Result:='';
  Analyzer:=Editors.Items[Editors.Index].Adapter.Lexer;
  if Assigned(Analyzer) then Result:= AnsiString(Analyzer.LineComment);
  ShowMessage(Result);  }
end;

//Lexer: Включение/отключение Лексера
procedure TfmMain.actLexerLexerExecute(Sender: TObject);
begin
 { Editors.SwitchLexer(actLexerLexer.Checked);  }
  { TODO -cActLexerLexer : Позже надо раскоментировать }
  //actLexerLexer.Checked:=Editors.LexerStatus;
end;

//Lexer: Выбор Лексера (из меню/тулбара)
procedure TfmMain.MenuChangeLexerClick(Sender: TObject);
begin
{  Editors.SetLexer((Sender as TMenuItem).Caption);  }
end;

//Consol: Выполнение комнды по нажатию Enter
procedure TfmMain.comboConsoleKeyPress(Sender: TObject; var Key: char);
begin
  if Key=#13 then begin
    //DoCommand
    comboConsole.Items.Add(comboConsole.Text);
    comboConsole.Text:='';
  end;
end;

//Bookmarks: Переключение закладки
procedure TfmMain.EditClickGutter(Sender: TObject; ABand, ALine: integer);
begin
 { if ABand=Editors.Items[Editors.Index].Editor.GutterBandBm then
  begin
    if Editors.Items[Editors.Index].Editor.Strings.LinesBm[ALine]<>0 then
    begin
      Editors.Items[Editors.Index].Editor.Strings.LinesBm[ALine]:= 0;
      Editors.Items[Editors.Index].Editor.Strings.LinesHint[ALine]:= '';
    end
    else
    begin
      Editors.Items[Editors.Index].Editor.Strings.LinesBm[ALine]:= 2;
      Editors.Items[Editors.Index].Editor.Strings.LinesHint[ALine]:= Format('Bookmark for line %d', [ALine+1]);
    end;
    Editors.Items[Editors.Index].Editor.Update;
  end;                }
end;

//Bookmarks: Рисование закладки
procedure TfmMain.OnDrawBookmarkIcon(Sender: TObject; C: TCanvas;
  ALineNum: integer; const ARect: TRect);
var
  Rect: TRect;
  dx: integer;
begin
  Rect:= ARect;
  if IsRectEmpty(Rect) then exit;
  C.Brush.Color:= clGreen;//cColorBmIco;
  C.Pen.Color:= clGreen;//cColorBmIco;
  inc(Rect.Top, 1);
  inc(Rect.Left, 4);
  dx:= (Rect.Bottom-Rect.Top) div 2-1;
  c.Polygon([Point(Rect.left, Rect.top), Point(Rect.left+dx, Rect.top+dx), Point(Rect.left, Rect.top+2*dx)]);
end;

//Functions: Поиск узла по имени
function TfmMain.GetNodeByName(ATree: TTreeView; ACaption: String): TTreeNode;
var
  searching: Boolean;
begin
  Result := ATree.Items[0];
  searching := true;
  while (searching) and (Result <> nil) do begin
    if Result.Text = ACaption then begin
      searching := false;
      ATree.Selected := Result;
      ATree.Setfocus;
    end
    else begin
      Result := Result.GetNext;
    end;
  end;
end;

//Functions: Получение слова под курсором мыши, номера строки, смещение 1го и последнего символов слова
function TfmMain.GetWordByCoords(AEditor: TATSynEdit; const Coords: TPoint; out APosition: TPoint; out AOffset1, AOffset2: Integer): String;
var
  EOLFlag: Boolean;
begin
  Result:='';
  APosition:=AEditor.ClientPosToCaretPos(Coords,EOLFlag);
  if EOLFlag then begin
    AOffset1:=APosition.x;
    AOffset2:=APosition.x;
    exit;
  end;
  if APosition.y>=0 then begin
    SFindWordBounds(AEditor.Strings.Lines[APosition.y],APosition.x,AOffset1,
                    AOffset2,AEditor.OptWordChars);
    Result:=AnsiString(Copy(AEditor.Strings.Lines[APosition.y],AOffset1+1,AOffset2-AOffset1));
  end;
end;

//Hints: Поиск метки/команды под курсором, вывод Хинта
{ TODO -chints : Для меток и дефайнов
Вывод в хинт строки целиком,
Если строкой выше есть символ */ - ищем начало комментария, выводим все строки,
Если строка выше начинается с ; - ищем все строки, начинающиеся с ; - выводим
Поиск команд
Берем строку от слова до комментария/двоеточия/конца строки, ищем ее среди рег. выражений операций}
procedure TfmMain.EditorMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  EdPos: TPoint;
  //EOFFlag: Boolean;
  Offset1, Offset2: Integer;
  Word: String;
begin
 { Application.CancelHint;
  Word:=GetWordByCoords(Editors.Items[Editors.Index].Editor,Point(X,Y),EdPos,Offset1,Offset2);
  Application.ActivateHint(Mouse.CursorPos);
  if Word<>'' then Editors.Items[Editors.Index].Editor.Hint:='"'+Word+'"'
  else Editors.Items[Editors.Index].Editor.Hint:='';      }
end;

//Operations: Переход по ссылке
procedure TfmMain.EditorMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  EdPos: TPoint;
  //EOFFlag: Boolean;
  Offset1, Offset2: Integer;
  Word: String;
  Node: TTreeNode;
  Range: TecTextRange;
begin
 { if (not(ssCtrl in Shift)) or (Button <> mbLeft) then exit;
  Word:=GetWordByCoords(Editors.Items[Editors.Index].Editor,Point(X,Y),EdPos,Offset1,Offset2);
  if Word='' then exit;
  Node:=GetNodeByName(tvCode, Word);
  if Node=nil then exit;
  if Node.Data=nil then exit;
  Range:=TecTextRange(Node.Data);
  //Получение координат (строка/столбец) перехода
  EdPos:=Editors.Items[Editors.Index].Adapter.TreeGetPositionOfRange(Range);
  //Переход к нужным координатам
  Editors.Items[Editors.Index].Editor.DoGotoPos_AndUnfold(EdPos, Point(-1, -1), 5, 5);
  Editors.Items[Editors.Index].Editor.SetFocus;    }
end;

function TfmMain.GetFrame(N: integer): TEditorFrame;
var
  D: TATTabData;
begin
  D:=tabsEditor.GetTabData(N);
  if D=nil then
    Result:= nil
  else
    Result:= D.TabObject as TEditorFrame;
end;

function TfmMain.DoFileOpen(AFilename: string{; APages: TATPages}): TEditorFrame;
var
  D: TATTabData;
  F: TEditorFrame;
  i: integer;
  isOem: boolean;
begin
  Result:= nil;
  //AppFolderOfLastInstalledAddon:= '';
  if Application.Terminated then exit;

  //if APages=nil then
  //  APages:= Groups.PagesCurrent;

  if AFilename='' then
  begin
    D:= DoTabAdd({APages, }{GetUntitledCaption}'noname.a80');
    Result:= D.TabObject as TEditorFrame;
    EditorFocus(Result.Editor);
    Exit
  end;
  {
  //expand "./name"
  AFilename:= ExpandFileNameUTF8(AFilename);

  if not FileExistsUTF8(AFilename) then
  begin
    MsgBox(msgCannotFindFile+#13+AFilename, mb_ok or mb_iconerror);
    Exit
  end;

  //zip files
  if ExtractFileExt(AFilename)='.zip' then
  begin
    DoFileInstallZip(AFilename, AppFolderOfLastInstalledAddon);
    exit
  end;

  //py event
  if FAllowEventOnOpenBefore then
    if DoPyEvent(CurrentEditor, cEventOnOpenBefore,
      [SStringToPythonString(AFilename)]) = cPyFalse then exit;

  //NonTextFiles: 0: prompt, 1: open, 2: don't open
  if not IsFilenameListedInExtensionList(AFilename, UiOps.PictureTypes) then
  if UiOps.NonTextFiles<>1 then
    if not IsFileContentText(AFilename, UiOps.NonTextFilesBufferKb, false, IsOem) then
      case UiOps.NonTextFiles of
        0:
          begin
            if MsgBox(Format(msgConfirmOpenNotText, [AFilename]),
              MB_OKCANCEL or MB_ICONWARNING)<>id_ok then Exit;
          end;
        2:
          Exit;
      end;

  //too big size?
  if FileSize(AFileName) div (1024*1024) >= UiOps.MaxFileSizeToOpen then
  begin
    MsgBox(msgCannotOpenTooBig+#13+AFileName, MB_OK or MB_ICONWARNING);
    exit
  end;

  //is file already opened? activate frame
  for i:= 0 to FrameCount-1 do
  begin
    F:= Frames[i];
    if CompareFilenames(F.FileName, AFilename)=0 then
    begin
      SetFrame(F);
      Result:= F;
      EditorFocus(Result.Editor);
      UpdateStatus;
      UpdateTree(true);
      Exit
    end;
  end;

  //is current frame empty? use it
  if APages=Groups.PagesCurrent then
  begin
    F:= CurrentFrame;
    if Assigned(F) then
    if F.IsEmpty then
    begin
      F.DoFileOpen(AFilename, true);
      Result:= F;
      UpdateStatus;
      MsgStatus(msgStatusOpened+' '+ExtractFileName(AFilename));
      DoPyEvent(F.Editor, cEventOnOpen, []);
      Exit
    end;
  end;

  D:= DoTabAdd(APages, ExtractFileName(AFilename));
  F:= D.TabObject as TEditorFrame;
  F.DoFileOpen(AFilename, true);
  Result:= F;

  UpdateStatus;
  MsgStatus(msgStatusOpened+' '+ExtractFileName(AFilename));
  DoPyEvent(F.Editor, cEventOnOpen, []);
  EditorFocus(Result.Editor);       }
end;

function TfmMain.DoTabAdd(const ACaption: string): TATTabData;
var
  F: TEditorFrame;
  NTab: integer;
begin
  F:= TEditorFrame.Create(Self);
  F.Name:= '';
  F.Visible:= false;
  F.TabCaption:= ACaption;

  //InitFrameEvents(F);

  //Pages.AddTab(F, F.TabCaption, false);
  tabsEditor.AddTab(-1,F.TabCaption,F,false);
  //NTab:= Pages.Tabs.TabCount-1;
  NTab:=tabsEditor.TabCount-1;
  //Result:= Pages.Tabs.GetTabData(NTab);
  Result:=tabsEditor.GetTabData(NTab);
  //Pages.Tabs.TabIndex:= NTab;
  tabsEditor.TabIndex:=NTab;
end;

function GetUntitledCaption: string;
begin
  //Inc(FUntitledCount);
  //Result:= msgUntitledTab+IntToStr(FUntitledCount);
end;

end.

