unit uSettings;
{$i Keys.inc}
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  StdCtrls, ExtCtrls, Spin, EditBtn, ColorBox, ResourceStringList;

type

  { TfmSettings }

  TfmSettings = class(TForm)
    bevGutter: TBevel;
    btCancel: TButton;
    btDown: TButton;
    btOk: TButton;
    btUp: TButton;
    bvlSetting: TBevel;
    checkGutterBandBm: TCheckBox;
    checkGutterBandEmpty: TCheckBox;
    checkGutterBandFold: TCheckBox;
    checkGutterBandNum: TCheckBox;
    checkGutterBandSep: TCheckBox;
    checkGutterBandState: TCheckBox;
    checkOptNumbersAutosize: TCheckBox;
    chkOptUnprintedEnds: TCheckBox;
    chkOptUnprintedEndsDetails: TCheckBox;
    chkOptUnprintedSpaces: TCheckBox;
    chkOptUnprintedVisible: TCheckBox;
    checkSaveCurrentPath: TCheckBox;
    chkOptCopyLinesIfNoSel: TCheckBox;
    chkOptCutLinesIfNoSel: TCheckBox;
    chkOptGutterShowFoldAlways: TCheckBox;
    chkOptGutterShowFoldLines: TCheckBox;
    chkOptGutterShowFoldLinesAll: TCheckBox;
    chkOptLastLineOnTop: TCheckBox;
    chkOptNumbersShowCarets: TCheckBox;
    chkOptNumbersShowFirst: TCheckBox;
    chkOptOverwriteAllowedOnPaste: TCheckBox;
    chkOptSavingForceFinalEol: TCheckBox;
    chkOptSavingTrimSpaces: TCheckBox;
    chkOptShowCurColumn: TCheckBox;
    chkOptShowCurLine: TCheckBox;
    chkOptShowCurLineMinimal: TCheckBox;
    chkOptShowFullHilite: TCheckBox;
    chkOptShowFullSel: TCheckBox;
    chkOptShowGutterCaretBG: TCheckBox;
    chkOptShowIndentLines: TCheckBox;
    chkOptShowScrollHint: TCheckBox;
    colorBlockSepLine: TColorBox;
    colorBlockStaple: TColorBox;
    colorBookmarkBG: TColorBox;
    colorBorderLine: TColorBox;
    colorCaret: TColorBox;
    colorCollapseLine: TColorBox;
    colorCollapseMarkBG: TColorBox;
    colorCollapseMarkBorder: TColorBox;
    colorCollapseMarkFont: TColorBox;
    colorComboboxArrow: TColorBox;
    colorComboboxArrowBG: TColorBox;
    colorCurrentLineBG: TColorBox;
    colorGutterBG: TColorBox;
    colorGutterCaretBG: TColorBox;
    colorGutterCaretFont: TColorBox;
    colorGutterFoldBG: TColorBox;
    colorGutterFoldLine: TColorBox;
    colorGutterFont: TColorBox;
    colorGutterPlusBG: TColorBox;
    colorGutterPlusBorder: TColorBox;
    colorGutterSeparatorBG: TColorBox;
    colorIndentVertLines: TColorBox;
    colorLinks: TColorBox;
    colorLockedBG: TColorBox;
    colorMarginCaret: TColorBox;
    colorMarginRight: TColorBox;
    colorMarginUser: TColorBox;
    colorMarkedLinesBG: TColorBox;
    colorMarkers: TColorBox;
    colorMinimapBorder: TColorBox;
    colorMinimapSelBG: TColorBox;
    colorRulerBG: TColorBox;
    colorRulerFont: TColorBox;
    colorStateAdded: TColorBox;
    colorStateChanged: TColorBox;
    colorStateSaved: TColorBox;
    colorTextBG: TColorBox;
    colorTextDisabledBG: TColorBox;
    colorTextDisabledFont: TColorBox;
    colorTextFont: TColorBox;
    colorTextHintFont: TColorBox;
    colorTextSelBG: TColorBox;
    colorTextSelFont: TColorBox;
    colorUnprintedBG: TColorBox;
    colorUnprintedFont: TColorBox;
    colorUnprintedHexFont: TColorBox;
    comboOptNumbersAlignment: TComboBox;
    comboOptNumbersStyle: TComboBox;
    edEmulFileName: TFileNameEdit;
    edEmulParams: TFileNameEdit;
    edGutterBandBm: TSpinEdit;
    edGutterBandEmpty: TSpinEdit;
    edGutterBandFold: TSpinEdit;
    edGutterBandNum: TSpinEdit;
    edGutterBandSep: TSpinEdit;
    edGutterBandState: TSpinEdit;
    edOptGutterPlusSize: TSpinEdit;
    edOptNumbersFontSize: TSpinEdit;
    edOptNumbersIndentLeft: TSpinEdit;
    edOptNumbersIndentRight: TSpinEdit;
    edOptNumbersSkippedChar: TEdit;
    edOptRulerFontSize: TSpinEdit;
    edOptRulerSize: TSpinEdit;
    edOptRulerTextIndent: TSpinEdit;
    edOptTextHint: TEdit;
    edOptWordChars: TEdit;
    edProjectsPath: TDirectoryEdit;
    edSjASMPlusFileName: TFileNameEdit;
    edSjASMPlusParams: TEdit;
    groupEditorColors: TGroupBox;
    groupEmul: TGroupBox;
    groupFiles: TGroupBox;
    groupFold: TGroupBox;
    groupGutter2: TGroupBox;
    groupGutterOrder: TGroupBox;
    groupLineNumbers: TGroupBox;
    groupOperations: TGroupBox;
    groupProjectsPath: TGroupBox;
    groupRuler: TGroupBox;
    groupSjASMPlus: TGroupBox;
    groupUnprinted: TGroupBox;
    groupView: TGroupBox;
    lblBlockSepLine: TLabel;
    lblBlockStaple: TLabel;
    lblBookmarkBG: TLabel;
    lblBorderLine: TLabel;
    lblCaret: TLabel;
    lblCollapseLine: TLabel;
    lblCollapseMarkBG: TLabel;
    lblCollapseMarkBorder: TLabel;
    lblCollapseMarkFont: TLabel;
    lblComboboxArrow: TLabel;
    lblComboboxArrowBG: TLabel;
    lblCurrentLineBG: TLabel;
    lblGutterBandEmpty: TLabel;
    lblEmulexe: TLabel;
    lblEmulParams: TLabel;
    lblGutter1: TLabel;
    lblGeneral3: TLabel;
    lblGeneral4: TLabel;
    lblGutter2: TLabel;
    lblGutterBandBm: TLabel;
    lblGutterBandFold: TLabel;
    lblGutterBandNum: TLabel;
    lblGutterBandSep: TLabel;
    lblGutterBandState: TLabel;
    lblGutterBG: TLabel;
    lblGutterCaretBG: TLabel;
    lblGutterCaretFont: TLabel;
    lblGutterFoldBG: TLabel;
    lblGutterFoldLine: TLabel;
    lblGutterFont: TLabel;
    lblGutterPlusBG: TLabel;
    lblGutterPlusBorder: TLabel;
    lblGutterSeparatorBG: TLabel;
    lblIndentVertLines: TLabel;
    lblLinks: TLabel;
    lblLockedBG: TLabel;
    lblMarginCaret: TLabel;
    lblMarginRight: TLabel;
    lblMarginUser: TLabel;
    lblMarkedLinesBG: TLabel;
    lblMarkers: TLabel;
    lblMinimapBorder: TLabel;
    lblMinimapSelBG: TLabel;
    lblRulerBG: TLabel;
    lblOptGutterPlusSize: TLabel;
    lblOptNumbersFontSize: TLabel;
    lblOptNumbersIndentLeft: TLabel;
    lblOptNumbersIndentRight: TLabel;
    lblOptNumbersSkippedChar: TLabel;
    lblOptRulerFontSize: TLabel;
    lblOptRulerSize: TLabel;
    lblOptRulerTextIndent: TLabel;
    lblRulerFont: TLabel;
    lblStateAdded: TLabel;
    lblSjasmexe: TLabel;
    lblSjASMPlusParams: TLabel;
    lblStateChanged: TLabel;
    lblStateSaved: TLabel;
    lblTextBG: TLabel;
    lblTextDisabledBG: TLabel;
    lblTextDisabledFont: TLabel;
    lblTextFont: TLabel;
    lblTextHintFont: TLabel;
    lblTextSelBG: TLabel;
    lblTextSelFont: TLabel;
    lblUnprintedBG: TLabel;
    lblUnprintedFont: TLabel;
    lblUnprintedHexFont: TLabel;
    listGutterColumns: TListBox;
    nbSettings: TNotebook;
    pageEditorColors: TPage;
    pageEditorUnprinted: TPage;
    pageEditorGutter2: TPage;
    pageGeneralFiles: TPage;
    pageEditorGeneral: TPage;
    pageEditorGutter: TPage;
    scrollColors: TScrollBox;
    splitGutter: TSplitter;
    splitSettings: TSplitter;
    tvSettings: TTreeView;
    procedure btDownClick(Sender: TObject);
    procedure btUpClick(Sender: TObject);
    procedure checkGutterBandBmChange(Sender: TObject);
    procedure checkGutterBandEmptyChange(Sender: TObject);
    procedure checkGutterBandFoldChange(Sender: TObject);
    procedure checkGutterBandNumChange(Sender: TObject);
    procedure checkGutterBandSepChange(Sender: TObject);
    procedure checkGutterBandStateChange(Sender: TObject);
    procedure checkOptNumbersAutosizeChange(Sender: TObject);
    procedure chkOptUnprintedEndsChange(Sender: TObject);
    procedure chkOptUnprintedVisibleChange(Sender: TObject);
    procedure chkOptGutterShowFoldLinesChange(Sender: TObject);
    procedure chkOptShowCurLineChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tvSettingsChange(Sender: TObject; Node: TTreeNode);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fmSettings: TfmSettings;

implementation

{$R *.lfm}

{ TfmSettings }

procedure TfmSettings.chkOptShowCurLineChange(Sender: TObject);
begin
  chkOptShowCurLineMinimal.Enabled:=chkOptShowCurLine.Checked;
end;

procedure TfmSettings.FormCreate(Sender: TObject);
begin
  comboOptNumbersStyle.Clear;
  comboOptNumbersStyle.Items.Add(stcomboOptNumbersStyle0);
  comboOptNumbersStyle.Items.Add(stcomboOptNumbersStyle1);
  comboOptNumbersStyle.Items.Add(stcomboOptNumbersStyle3);
  comboOptNumbersStyle.Items.Add(stcomboOptNumbersStyle2);
  //comboOptNumbersStyle.ItemIndex:=0;
  comboOptNumbersAlignment.Clear;
  comboOptNumbersAlignment.Items.Add(stcomboOptNumbersAlignment0);
  comboOptNumbersAlignment.Items.Add(stcomboOptNumbersAlignment1);
  comboOptNumbersAlignment.Items.Add(stcomboOptNumbersAlignment2);
  //comboOptNumbersAlignment.ItemIndex:=1;
end;

procedure TfmSettings.chkOptGutterShowFoldLinesChange(Sender: TObject);
begin
  chkOptGutterShowFoldLinesAll.Enabled:=chkOptGutterShowFoldLines.Checked;
end;

procedure TfmSettings.checkOptNumbersAutosizeChange(Sender: TObject);
begin
  edGutterBandNum.Enabled:=not checkOptNumbersAutosize.Checked;
  edGutterBandNum.Value:=31;
end;

procedure TfmSettings.chkOptUnprintedEndsChange(Sender: TObject);
begin
  chkOptUnprintedEndsDetails.Enabled:=(chkOptUnprintedVisible.Checked and chkOptUnprintedEnds.Checked);
end;

procedure TfmSettings.chkOptUnprintedVisibleChange(Sender: TObject);
begin
  chkOptUnprintedSpaces.Enabled:=chkOptUnprintedVisible.Checked;
  chkOptUnprintedEnds.Enabled:=chkOptUnprintedVisible.Checked;
  chkOptUnprintedEndsDetails.Enabled:=(chkOptUnprintedVisible.Checked and chkOptUnprintedEnds.Checked);
end;

procedure SwapItems(L: TListbox; n1, n2: integer);
var
  s: string;
begin
  s:= L.Items[n1];
  L.Items[n1]:= L.Items[n2];
  L.Items[n2]:= s;
  L.ItemIndex:= n2;
end;

procedure TfmSettings.btUpClick(Sender: TObject);
begin
  with listGutterColumns do
    if ItemIndex>0 then
      SwapItems(listGutterColumns, ItemIndex, ItemIndex-1);
end;

procedure TfmSettings.checkGutterBandBmChange(Sender: TObject);
begin
  edGutterBandBm.Enabled:=checkGutterBandBm.Checked;
  lblGutterBandBm.Enabled:=checkGutterBandBm.Checked;
end;

procedure TfmSettings.checkGutterBandEmptyChange(Sender: TObject);
begin
  edGutterBandEmpty.Enabled:=checkGutterBandEmpty.Checked;
  lblGutterBandEmpty.Enabled:=checkGutterBandEmpty.Checked;
end;

procedure TfmSettings.checkGutterBandFoldChange(Sender: TObject);
begin
  edGutterBandFold.Enabled:=checkGutterBandFold.Checked;
  lblGutterBandFold.Enabled:=checkGutterBandFold.Checked;
end;

procedure TfmSettings.checkGutterBandNumChange(Sender: TObject);
begin
  edOptNumbersIndentLeft.Enabled:=checkGutterBandNum.Checked;
  lblOptNumbersIndentLeft.Enabled:=checkGutterBandNum.Checked;
  checkOptNumbersAutosize.Enabled:=checkGutterBandNum.Checked;
  edGutterBandNum.Enabled:=checkGutterBandNum.Checked and not checkOptNumbersAutosize.Checked;
  lblGutterBandNum.Enabled:=checkGutterBandNum.Checked and not checkOptNumbersAutosize.Checked;
  edOptNumbersIndentRight.Enabled:=checkGutterBandNum.Checked;
  lblOptNumbersIndentRight.Enabled:=checkGutterBandNum.Checked;
end;

procedure TfmSettings.checkGutterBandSepChange(Sender: TObject);
begin
  edGutterBandSep.Enabled:=checkGutterBandSep.Checked;
  lblGutterBandSep.Enabled:=checkGutterBandSep.Checked;
end;

procedure TfmSettings.checkGutterBandStateChange(Sender: TObject);
begin
  edGutterBandState.Enabled:=checkGutterBandState.Checked;
  lblGutterBandState.Enabled:=checkGutterBandState.Checked;
end;

procedure TfmSettings.btDownClick(Sender: TObject);
begin
  with listGutterColumns do
    if ItemIndex<Count-1 then
      SwapItems(listGutterColumns, ItemIndex, ItemIndex+1);
end;

procedure TfmSettings.tvSettingsChange(Sender: TObject; Node: TTreeNode);
var
  pageNumber: integer;
begin
  case Node.AbsoluteIndex of
    0: PageNumber:=2;
    1: PageNumber:=2;
    2: PageNumber:=0;
    3: PageNumber:=0;
    4: PageNumber:=1;
    5: PageNumber:=3;
    6: PageNumber:=4;
    7: PageNumber:=5;
  end;
  nbSettings.PageIndex:=pageNumber;
end;

end.

