unit uZ80AsmHelp;
{Z80 Instruction Help Strings}

{$mode objfpc}

interface

resourcestring
  stZ80_00='NOP'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 00'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'No operation is performed.';
  stZ80_01='LD BC,**'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 01'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads ** into BC.';
  stZ80_02='LD (BC),A'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 02'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Stores a into the memory location pointed to by BC.';
  stZ80_03='INC BC'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 03'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Adds one to BC.';
  stZ80_04='INC B'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 04'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to B.';
  stZ80_05='DEC B'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 05'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from B.';
  stZ80_06='LD B,*'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 06'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into B.';
  stZ80_07='RLCA'+#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 07'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: reset'#13#10+
           'P/V: unaffected'#13#10+
           'H: reset'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_08='EX AF,AF#39'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 08'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Exchanges the 16-bit contents of AF and AF#39.';
  stZ80_09='ADD HL,BC'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 09'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: unaffected'#13#10+
           'H: affected as defined'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The value of BC is added to HL.';
  stZ80_0A='LD A,(BC)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 0A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads the value pointed to by BC into A.';
  stZ80_0B='DEC BC'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 0B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Subtracts one from BC.';
  stZ80_0C='INC C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 0C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to C.';
  stZ80_0D='DEC C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 0D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from C.';
  stZ80_0E='LD C,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 0E'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into C.';
  stZ80_0F='RRCA'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 0F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: reset'#13#10+
           'P/V: unaffected'#13#10+
           'H: reset'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';

  stZ80_10='DJNZ *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 10'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 13/8'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The B register is decremented, and if not zero, the signed value * is added to PC. The jump is measured from the start of the instruction opcode.';
  stZ80_11='LD DE,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 11'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads ** into DE.';
  stZ80_12='LD (DE),A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 12'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Stores A into the memory location pointed to by DE.';
  stZ80_13='INC DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 13'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Adds one to DE.';
  stZ80_14='INC D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 14'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to D.';
  stZ80_15='DEC D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 15'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from D.';
  stZ80_16='LD D,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 16'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into D.';
  stZ80_17='RLA'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 17'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: reset'#13#10+
           'P/V: unaffected'#13#10+
           'H: reset'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_18='JR *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 18'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 12'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The signed value * is added to PC. The jump is measured from the start of the instruction opcode.';
  stZ80_19='ADD HL,DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 19'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: unaffected'#13#10+
           'H: affected as defined'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The value of DE is added to HL.';
  stZ80_1A='LD A,(DE)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 1A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads the value pointed to by DE into A.';
  stZ80_1B='DEC DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 1B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Subtracts one from DE.';
  stZ80_1C='INC DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 1C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to E.';
  stZ80_1D='DEC DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 1D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from E.';
  stZ80_1E='LD E,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 1E'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into E.';
  stZ80_1F='RRA'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 1F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: reset'#13#10+
           'P/V: unaffected'#13#10+
           'H: reset'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';

  stZ80_20='JR NZ,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 20'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 12/7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NZ is true, the signed value * is added to PC. The jump is measured from the start of the instruction opcode.';
  stZ80_21='LD HL,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 21'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads ** into HL.';
  stZ80_22='LD (**),HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 22'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 16'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Stores HL into the memory location pointed to by **.';
  stZ80_23='INC HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 23'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Adds one to HL.';
  stZ80_24='INC H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 24'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to H.';
  stZ80_25='DEC H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 25'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from H.';
  stZ80_26='LD H,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 26'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into H.';
  stZ80_27='DAA'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 27'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: exceptionalunknown'#13#10+
           'N: unaffected'#13#10+
           'P/V: detects parity'#13#10+
           'H: exceptionalunknown'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adjusts a for BCD addition and subtraction operations.';
  stZ80_28='JR Z,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 28'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 12/7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition Z is true, the signed value * is added to PC. The jump is measured from the start of the instruction opcode.';
  stZ80_29='ADD HL,HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 29'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: unaffected'#13#10+
           'H: affected as defined'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The value of HL is added to HL.';
  stZ80_2A='LD HL,(**)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 2A'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 16'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads the value pointed to by ** into HL.';
  stZ80_2B='DEC HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 2B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Subtracts one from HL.';
  stZ80_2C='INC L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 2C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to L.';
  stZ80_2D='DEC L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 2D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from L.';
  stZ80_2E='LD L,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 2E'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into L.';
  stZ80_2F='CPL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 2F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: set'#13#10+
           'P/V: unaffected'#13#10+
           'H: set'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are inverted (one#39s complement).';

  stZ80_30='JR NC,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 30'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 12/7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NC is true, the signed value * is added to PC. The jump is measured from the start of the instruction opcode.';
  stZ80_31='LD SP,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 31'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads ** into SP.';
  stZ80_32='LD (**),A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 32'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 13'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Stores A into the memory location pointed to by **.';
  stZ80_33='INC SP'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 33'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Adds one to SP.';
  stZ80_34='INC (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 34'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to (HL).';
  stZ80_35='DEC (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 35'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from (HL).';
  stZ80_36='LD (HL),*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 36'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into (HL).';
  stZ80_37='SCF'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 37'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: set'#13#10+
           'N: reset'#13#10+
           'P/V: unaffected'#13#10+
           'H: reset'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Sets the carry flag.';
  stZ80_38='JR C,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 38'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 12/7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition C is true, the signed value * is added to PC. The jump is measured from the start of the instruction opcode.';
  stZ80_39='ADD HL,SP'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 39'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: unaffected'#13#10+
           'H: affected as defined'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The value of SP is added to HL.';
  stZ80_3A='LD A,(**)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 3A'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 13'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads the value pointed to by ** into A.';
  stZ80_3B='DEC SP'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 3B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Subtracts one from SP.';
  stZ80_3C='INC A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 3C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds one to A.';
  stZ80_3D='DEC A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 3D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts one from A.';
  stZ80_3E='LD A,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 3E'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads * into A.';
  stZ80_3F='CCF'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 3F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: exceptionalunknown'#13#10+
           'N: reset'#13#10+
           'P/V: unaffected'#13#10+
           'H: exceptionalunknown'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Inverts the carry flag.';

  stZ80_40='LD B,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 40'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into B.';
  stZ80_41='LD B,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 41'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into B.';
  stZ80_42='LD B,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 42'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into B.';
  stZ80_43='LD B,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 43'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into B.';
  stZ80_44='LD B,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 44'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into B.';
  stZ80_45='LD B,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 45'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into B.';
  stZ80_46='LD B,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 46'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into B.';
  stZ80_47='LD B,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 47'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into B.';
  stZ80_48='LD C,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 48'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into C.';
  stZ80_49='LD C,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 49'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into C.';
  stZ80_4A='LD C,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 4A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into C.';
  stZ80_4B='LD C,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 4B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into C.';
  stZ80_4C='LD C,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 4C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into C.';
  stZ80_4D='LD C,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 4D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into C.';
  stZ80_4E='LD C,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 4E'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into C.';
  stZ80_4F='LD C,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 4F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into C.';

  stZ80_50='LD D,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 50'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into D.';
  stZ80_51='LD D,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 51'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into D.';
  stZ80_52='LD D,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 52'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into D.';
  stZ80_53='LD D,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 53'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into D.';
  stZ80_54='LD D,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 54'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into D.';
  stZ80_55='LD D,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 55'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into D.';
  stZ80_56='LD D,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 56'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into D.';
  stZ80_57='LD D,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 57'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into D.';
  stZ80_58='LD E,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 58'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into E.';
  stZ80_59='LD E,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 59'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into E.';
  stZ80_5A='LD E,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 5A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into E.';
  stZ80_5B='LD E,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 5B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into E.';
  stZ80_5C='LD E,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 5C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into E.';
  stZ80_5D='LD E,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 5D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into E.';
  stZ80_5E='LD E,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 5E'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into E.';
  stZ80_5F='LD E,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 5F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into E.';
  stZ80_60='LD H,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 60'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into H.';
  stZ80_61='LD H,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 61'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into H.';
  stZ80_62='LD H,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 62'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into H.';
  stZ80_63='LD H,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 63'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into H.';
  stZ80_64='LD H,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 64'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into H.';
  stZ80_65='LD H,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 65'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into H.';
  stZ80_66='LD H,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 66'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into H.';
  stZ80_67='LD H,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 67'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into H.';
  stZ80_68='LD L,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 68'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into L.';
  stZ80_69='LD L,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 69'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into L.';
  stZ80_6A='LD L,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 6A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into L.';
  stZ80_6B='LD L,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 6B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into L.';
  stZ80_6C='LD L,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 6C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into L.';
  stZ80_6D='LD L,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 6D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into L.';
  stZ80_6E='LD L,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 6E'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into L.';
  stZ80_6F='LD L,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 6F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into L.';

  stZ80_70='LD (HL),B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 70'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into (HL).';
  stZ80_71='LD (HL),C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 71'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into (HL).';
  stZ80_72='LD (HL),D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 72'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into (HL).';
  stZ80_73='LD (HL),E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 73'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into (HL).';
  stZ80_74='LD (HL),H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 74'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into (HL).';
  stZ80_75='LD (HL),L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 75'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into (HL).';
  stZ80_76='HALT'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 76'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Suspends CPU operation until an interrupt or reset occurs.';
  stZ80_77='LD (HL),A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 77'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into (HL).';
  stZ80_78='LD A,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 78'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of B are loaded into A.';
  stZ80_79='LD A,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 79'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of C are loaded into A.';
  stZ80_7A='LD A,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 7A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of D are loaded into A.';
  stZ80_7B='LD A,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 7B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of E are loaded into A.';
  stZ80_7C='LD A,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 7C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of H are loaded into A.';
  stZ80_7D='LD A,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 7D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of L are loaded into A.';
  stZ80_7E='LD A,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 7E'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of (HL) are loaded into A.';
  stZ80_7F='LD A,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 7F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The contents of A are loaded into A.';

  stZ80_80='ADD A,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 80'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds B to A.';
  stZ80_81='ADD A,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 81'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds C to A.';
  stZ80_82='ADD A,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 82'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds D to A.';
  stZ80_83='ADD A,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 83'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds E to A.';
  stZ80_84='ADD A,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 84'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds H to A.';
  stZ80_85='ADD A,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 85'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds L to A.';
  stZ80_86='ADD A,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 86'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds (HL) to A.';
  stZ80_87='ADD A,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 87'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds A to A.';
  stZ80_88='ADC A,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 88'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds B and the carry flag to A.';
  stZ80_89='ADC A,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 89'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds C and the carry flag to A.';
  stZ80_8A='ADC A,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 8A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds D and the carry flag to A.';
  stZ80_8B='ADC A,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 8B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds E and the carry flag to A.';
  stZ80_8C='ADC A,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 8C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds H and the carry flag to A.';
  stZ80_8D='ADC A,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 8D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds L and the carry flag to A.';
  stZ80_8E='ADC A,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 8E'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds (HL) and the carry flag to A.';
  stZ80_8F='ADC A,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 8F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds A and the carry flag to A.';

  stZ80_90='SUB B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 90'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts B from A.';
  stZ80_91='SUB C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 91'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts C from A.';
  stZ80_92='SUB D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 92'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts D from A.';
  stZ80_93='SUB E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 93'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts E from A.';
  stZ80_94='SUB H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 94'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts H from A.';
  stZ80_95='SUB L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 95'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts L from A.';
  stZ80_96='SUB (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 96'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts (HL) from A.';
  stZ80_97='SUB A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 97'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts A from A.';
  stZ80_98='SBC A,B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 98'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts B and the carry flag from A.';
  stZ80_99='SBC A,C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 99'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts C and the carry flag from A.';
  stZ80_9A='SBC A,D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 9A'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts D and the carry flag from A.';
  stZ80_9B='SBC A,E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 9B'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts E and the carry flag from A.';
  stZ80_9C='SBC A,H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 9C'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts H and the carry flag from A.';
  stZ80_9D='SBC A,L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 9D'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts L and the carry flag from A.';
  stZ80_9E='SBC A,(HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 9E'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts (HL) and the carry flag from A.';
  stZ80_9F='SBC A,A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: 9F'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts A and the carry flag from A.';

  stZ80_A0='AND B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A0'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with B.';
  stZ80_A1='AND C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A1'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with C.';
  stZ80_A2='AND D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A2'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with D.';
  stZ80_A3='AND E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A3'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with E.';
  stZ80_A4='AND H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A4'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with H.';
  stZ80_A5='AND L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A5'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with L.';
  stZ80_A6='AND (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A6'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with (HL).';
  stZ80_A7='AND A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A7'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with A.';
  stZ80_A8='XOR B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A8'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with B.';
  stZ80_A9='XOR C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: A9'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with C.';
  stZ80_AA='XOR D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: AA'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with D.';
  stZ80_AB='XOR E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: AB'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with E.';
  stZ80_AC='XOR H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: AC'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with H.';
  stZ80_AD='XOR L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: AD'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with L.';
  stZ80_AE='XOR (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: AE'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with (HL).';
  stZ80_AF='XOR A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: AF'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with A.';

  stZ80_B0='OR B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B0'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with B.';
  stZ80_B1='OR C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B1'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with C.';
  stZ80_B2='OR D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B2'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with D.';
  stZ80_B3='OR E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B3'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with E.';
  stZ80_B4='OR H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B4'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with H.';
  stZ80_B5='OR L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B5'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with L.';
  stZ80_B6='OR (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B6'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with (HL).';
  stZ80_B7='OR A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B7'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with A.';
  stZ80_B8='CP B'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B8'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts B from A and affects flags according to the result. A is not modified.';
  stZ80_B9='CP C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: B9'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts C from A and affects flags according to the result. A is not modified.';
  stZ80_BA='CP D'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: BA'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts D from A and affects flags according to the result. A is not modified.';
  stZ80_BB='CP E'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: BB'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts E from A and affects flags according to the result. A is not modified.';
  stZ80_BC='CP H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: BC'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts H from A and affects flags according to the result. A is not modified.';
  stZ80_BD='CP L'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: BD'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts L from A and affects flags according to the result. A is not modified.';
  stZ80_BE='CP (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: BE'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts (HL) from A and affects flags according to the result. A is not modified.';
  stZ80_BF='CP A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: BF'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts A from A and affects flags according to the result. A is not modified.';

  stZ80_C0='RET NZ'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C0'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NZ is true, the top stack entry is popped into PC.';
  stZ80_C1='POP BC'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C1'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The memory location pointed to by SP is stored into C and SP is incremented. The memory location pointed to by SP is stored into B and SP is incremented again.';
  stZ80_C2='JP NZ,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C2'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NZ is true, ** is copied to PC.';
  stZ80_C3='JP **'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C3'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           '** is copied to PC.';
  stZ80_C4='CALL NZ,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C4'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NZ is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  stZ80_C5='PUSH BC'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C5'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'SP is decremented and B is stored into the memory location pointed to by SP. SP is decremented again and C is stored into the memory location pointed to by SP.';
  stZ80_C6='ADD A,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C6'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds * to A.';
  stZ80_C7='RST 00H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C7'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 00h.';
  stZ80_C8='RET Z'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C8'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition Z is true, the top stack entry is popped into pc.';
  stZ80_C9='RET'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: C9'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The top stack entry is popped into PC.';
  stZ80_CA='JP Z,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: CA'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition Z is true, ** is copied to PC.';
  //stZ80_CB - Bit instructions prefix
  stZ80_CC='CALL Z,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: CC'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition Z is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  stZ80_CD='CALL **'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: CD'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus three is pushed onto the stack, then is loaded with **.';
  stZ80_CE='ADC A,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: CE'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Adds * and the carry flag to A.';
  stZ80_CF='RST 08H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: CD'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 08h.';

  stZ80_D0='RET NC'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D0'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NC is true, the top stack entry is popped into PC.';
  stZ80_D1='POP DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D1'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The memory location pointed to by SP is stored into E and SP is incremented. The memory location pointed to by SP is stored into D and SP is incremented again.';
  stZ80_D2='JP NC,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D2'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NC is true, ** is copied to PC.';
  stZ80_D3='OUT (*),A'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D3'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The value of A is written to port *.';
  stZ80_D4='CALL NC,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D4'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition NC is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  stZ80_D5='PUSH DE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D5'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'SP is decremented and D is stored into the memory location pointed to by SP. SP is decremented again and E is stored into the memory location pointed to by SP.';
  stZ80_D6='SUB *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D6'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts * from A.';
  stZ80_D7='RST 10H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D7'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 10h.';
  stZ80_D8='RET C'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D8'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition C is true, the top stack entry is popped into pc.';
  stZ80_D9='EXX'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: D9'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Exchanges the 16-bit contents of BC, DE, and HL with BC#39, DE#39, and HL#39.';
  stZ80_DA='JP C,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: DA'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition C is true, ** is copied to PC.';
  stZ80_DB='IN A,(*)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: DB'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'A byte from port * is written to A.';
  stZ80_DC='CALL C,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: DC'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition C is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  //stZ80_DD - IX instructions prefix
  stZ80_DE='SBC A,*'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: DE'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts * and the carry flag from A.';
  stZ80_DF='RST 18H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: DF'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 18h.';
  stZ80_E0='RET PO'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E0'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition PO is true, the top stack entry is popped into PC.';
  stZ80_E1='POP HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E1'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The memory location pointed to by SP is stored into L and SP is incremented. The memory location pointed to by SP is stored into H and SP is incremented again.';
  stZ80_E2='JP PO,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E2'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition PO is true, ** is copied to PC.';
  stZ80_E3='EX (SP),HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E3'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 19'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Exchanges (SP) with L, and (SP+1) with H.';
  stZ80_E4='CALL PO,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E4'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition PO is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  stZ80_E5='PUSH HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E5'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'SP is decremented and H is stored into the memory location pointed to by SP. SP is decremented again and L is stored into the memory location pointed to by SP.';
  stZ80_E6='AND *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E6'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: set'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise AND on A with *.';
  stZ80_E7='RST 20H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E7'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 20h.';
  stZ80_E8='RET PE'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E8'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition PE is true, the top stack entry is popped into PC.';
  stZ80_E9='JP (HL)'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: E9'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads the value of HL into PC.';
  stZ80_EA='JP PE,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: EA'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition PE is true, ** is copied to PC.';
  stZ80_EB='EX DE,HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: EB'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Exchanges the 16-bit contents of DE and HL.';
  stZ80_EC='CALL PE,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: EC'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition PE is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  //stZ80_ED - Extented instructions prefix
  stZ80_EE='XOR *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: EE'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise XOR on A with *.';
  stZ80_EF='RST 28H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: EF'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 28h.';

  stZ80_F0='RET P'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F0'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition P is true, the top stack entry is popped into PC.';
  stZ80_F1='POP AF'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F1'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The memory location pointed to by SP is stored into F and SP is incremented. The memory location pointed to by SP is stored into A and SP is incremented again.';
  stZ80_F2='JP P,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F2'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition P is true, ** is copied to PC.';
  stZ80_F3='DI'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F3'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Resets both interrupt flip-flops, thus prenting maskable interrupts from triggering.';
  stZ80_F4='CALL P,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F4'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition P is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  stZ80_F5='PUSH AF'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F5'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'SP is decremented and A is stored into the memory location pointed to by SP. SP is decremented again and F is stored into the memory location pointed to by SP.';
  stZ80_F6='OR *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F6'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: reset'#13#10+
           'N: reset'#13#10+
           'P/V: detects parity'#13#10+
           'H: reset'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Bitwise OR on A with *.';
  stZ80_F7='RST 30H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F7'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 30h.';
  stZ80_F8='RET M'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F8'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11/5'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition M is true, the top stack entry is popped into PC.';
  stZ80_F9='LD SP,HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: F9'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 6'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Loads the value of HL into SP.';
  stZ80_FA='LD SP,HL'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: FA'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition M is true, ** is copied to PC.';
  stZ80_FB='EI'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: FB'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 4'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'Sets both interrupt flip-flops, thus allowing maskable interrupts to occur. An interrupt will not occur until after the immediatedly following instruction.';
  stZ80_FC='CALL M,**'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: FC'#13#10+
           'Size (bytes): 3'#13#10+
           'Time (clock cycles): 17/10'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'If condition M is true, the current PC value plus three is pushed onto the stack, then is loaded with **.';
  //stZ80_FD - IY instructions prefix
  stZ80_FE='CP *'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: FE'#13#10+
           'Size (bytes): 2'#13#10+
           'Time (clock cycles): 7'#13#10+
           'C: affected as defined'#13#10+
           'N: affected as defined'#13#10+
           'P/V: detects overflow'#13#10+
           'H: affected as defined'#13#10+
           'Z: affected as defined'#13#10+
           'S: affected as defined'#13#10+
           'Subtracts * from A and affects flags according to the result. A is not modified.';
  stZ80_FF='RST 38H'#13#10+
           'Group: Main instructions'#13#10+
           'Opcode: FF'#13#10+
           'Size (bytes): 1'#13#10+
           'Time (clock cycles): 11'#13#10+
           'C: unaffected'#13#10+
           'N: unaffected'#13#10+
           'P/V: unaffected'#13#10+
           'H: unaffected'#13#10+
           'Z: unaffected'#13#10+
           'S: unaffected'#13#10+
           'The current PC value plus one is pushed onto the stack, then is loaded with 38h.';

  stZ80_ED40='IN B,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED40'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affectrd as defined'#13#10+
             'S: affectrd as defined'#13#10+
             'A byte from port C is written to B.';
  stZ80_ED41='OUT (C),B'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED41'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of B is written to port C.';
  stZ80_ED42='SBC HL,BC'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED42'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Subtracts BC and the carry flag from HL.';
  stZ80_ED43='LD (**),BC'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED43'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Stores BC into the memory location pointed to by **.';
  stZ80_ED44='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED44'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED45='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED45'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at #0066) to POP the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED46='IM 0'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED46'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets interrupt mode 0.';
  stZ80_ED47='LD I,A'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED47'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 9'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Stores the value of A into register I or R.';
  stZ80_ED48='IN C,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED48'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'A byte from port C is written to C.';
  stZ80_ED49='OUT (C),C'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED49'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of C is written to port C.';
  stZ80_ED4A='ADC HL,BC'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED4A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Adds BC and the carry flag to HL.';
  stZ80_ED4B='LD BC,(**)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED4B'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Loads the value pointed to by ** into BC.';
  stZ80_ED4C='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED4C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED4D='RETI'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED4D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a maskable interrupt service routine. The top stack entry is popped into PC, and signals an I/O device that the interrupt has finished, allowing nested interrupts (not a consideration on the TI).';
  stZ80_ED4E='IM 0/1'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED4E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets undefined interrupt mode 0/1.';
  stZ80_ED4F='LD R,A'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED4F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 9'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Stores the value of a into register i or r.';

  stZ80_ED50='IN D,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED50'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'A byte from port C is written to D.';
  stZ80_ED51='OUT (C),D'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED51'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of D is written to port C.';
  stZ80_ED52='SBC HL,DE'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED52'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'Subtracts DE and the carry flag from HL.';
  stZ80_ED53='LD (**),DE'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED53'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Stores DE into the memory location pointed to by **.';
  stZ80_ED54='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED54'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'The contents of A are negated (two#31s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED55='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED55'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at #0066) to POP the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED56='IM 1'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED56'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets interrupt mode 1.';
  stZ80_ED57='LD A,I'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED57'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 9'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: exceptionalunknown'#13#10+
             'H: reset'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'Stores the value of register I or R into A.';
  stZ80_ED58='IN E,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED58'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'A byte from port C is written to E.';
  stZ80_ED59='OUT (C),E'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED59'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of E is written to port C.';
  stZ80_ED5A='ADC HL,DE'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED5A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'Adds DE and the carry flag to HL.';
  stZ80_ED5B='LD DE,(**)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED5B'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Loads the value pointed to by ** into DE.';
  stZ80_ED5C='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED5C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED5D='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED5D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at #0066) to POP the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED5E='IM 2'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED5E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets interrupt mode 2.';
  stZ80_ED5F='LD A,R'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED5F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 9'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: exceptionalunknown'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Stores the value of register I or R into A.';

  stZ80_ED60='IN H,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED60'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'A byte from port C is written to H.';
  stZ80_ED61='OUT (C),H'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED61'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of H is written to port C.';
  stZ80_ED62='SBC HL,HL'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED62'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Subtracts HL and the carry flag from HL.';
  stZ80_ED63='LD (**),HL'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED63'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Stores HL into the memory location pointed to by **.';
  stZ80_ED64='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED64'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED65='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED65'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at $0066) to pop the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED66='IM 0'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED66'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets interrupt mode 0.';
  stZ80_ED67='RRD'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED67'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 18'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'The contents of the low-order nibble of (HL) are copied to the low-order nibble of A. The previous contents are copied to the high-order nibble of (HL). The previous contents are copied to the low-order nibble of (HL).';
  stZ80_ED68='IN L,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED68'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'A byte from port C is written to L.';
  stZ80_ED69='OUT (C),L'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED69'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of L is written to port C.';
  stZ80_ED6A='ADC HL,HL'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED6A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected as defined'#13#10+
             'N: affected as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Adds HL and the carry flag to HL.';
  stZ80_ED6B='LD HL,(**)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED6B'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Loads the value pointed to by ** into HL.';
  stZ80_ED6C='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED6C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED6D='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED6D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at $0066) to pop the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED6E='IM 0/1'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED6E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets undefined interrupt mode 0/1.';
  stZ80_ED6F='RLD'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED6F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 18'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'The contents of the low-order nibble of (HL) are copied to the high-order nibble of (HL). The previous contents are copied to the low-order nibble of A. The previous contents are copied to the low-order nibble of (HL).';

  stZ80_ED70='IN (C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED70'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Inputs a byte from port c and affects flags only.';
  stZ80_ED71='OUT (C),0'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED71'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Outputs a zero to port C.';
  stZ80_ED72='SBC HL,SP'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED72'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'Subtracts SP and the carry flag from HL.';
  stZ80_ED73='LD (**),SP'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED73'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Stores SP into the memory location pointed to by **.';
  stZ80_ED74='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED74'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED75='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED75'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at $0066) to pop the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED76='IM 1'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED76'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets interrupt mode 1.';
  //stZ80_ED77 - none
  stZ80_ED78='IN A,(C)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED78'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'A byte from port C is written to A.';
  stZ80_ED79='OUT (C),A'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED79'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'The value of A is written to port C.';
  stZ80_ED7A='ADC HL,SP'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED7A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'Adds HL and the carry flag to HL.';
  stZ80_ED7B='LD SP,(**)'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED7B'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Loads the value pointed to by ** into SP.';
  stZ80_ED7C='NEG'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: ED7C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: affected ad defined'#13#10+
             'N: affected ad defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: affected ad defined'#13#10+
             'Z: affected ad defined'#13#10+
             'S: affected ad defined'#13#10+
             'The contents of A are negated (two#39s complement). Operation is the same as subtracting A from zero.';
  stZ80_ED7D='RETN'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED7D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Used at the end of a non-maskable interrupt service routine (located at $0066) to pop the top stack entry into PC. The value of IFF2 is copied to IFF1 so that maskable interrupts are allowed to continue as before. NMIs are not enabled on the TI.';
  stZ80_ED7E='IM 2'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: ED7E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unaffected'#13#10+
             'N: unaffected'#13#10+
             'P/V: unaffected'#13#10+
             'H: unaffected'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Sets interrupt mode 2.';
  //stZ80_ED7F - none

  //stZ80_ED80-stZ80_ED9F - none

  stZ80_EDA0='LDI'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDA0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: exceptionalunknown'#13#10+
             'H: reset'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Transfers a byte of data from the memory location pointed to by HL to the memory location pointed to by DE. Then HL and DE are incremented and BC is decremented.';
  stZ80_EDA1='CPI'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDA1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: exceptionalunknown'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Compares the value of the memory location pointed to by hl with a. Then hl is incremented and bc is decremented.';
  stZ80_EDA2='INI'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDA2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: exceptionalunknown'#13#10+
             'S: unknown'#13#10+
             'A byte from port C is written to the memory location pointed to by HL. Then HL is incremented and B is decremented.';
  stZ80_EDA3='OUTI'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDA3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: exceptionalunknown'#13#10+
             'S: unknown'#13#10+
             'A byte from the memory location pointed to by HL is written to port C. Then HL is incremented and B is decremented.';
  //stZ80_EDA4-stZ80_EDA7 - none
  stZ80_EDA8='LDD'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDA8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: exceptionalunknown'#13#10+
             'H: reset'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Transfers a byte of data from the memory location pointed to by HL to the memory location pointed to by DE. Then HL, DE, and BC are decremented.';
  stZ80_EDA9='CPD'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDA9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: exceptionalunknown'#13#10+
             'H: affected as defined'#13#10+
             'Z: affected as defined'#13#10+
             'S: affected as defined'#13#10+
             'Compares the value of the memory location pointed to by HL with A. Then HL and BC are decremented.';
  stZ80_EDAA='IND'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDAA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: exceptionalunknown'#13#10+
             'S: unknown'#13#10+
             'A byte from port C is written to the memory location pointed to by HL. Then HL and B are decremented.';
  stZ80_EDAB='OUTD'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDAB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: exceptionalunknown'#13#10+
             'S: unknown'#13#10+
             'A byte from the memory location pointed to by HL is written to port C. Then HL and B are decremented.';
  //stZ80_EDAC-stZ80_EDAF - none

  stZ80_EDB0='LDIR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDB0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: reset'#13#10+
             'H: reset'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Transfers a byte of data from the memory location pointed to by HL to the memory location pointed to by DE. Then HL and DE are incremented and BC is decremented. If BC is not zero, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  stZ80_EDB1='CPIR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDB1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: reset'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Compares the value of the memory location pointed to by HL with A. Then HL is incremented and BC is decremented. If BC is not zero and Z is not set, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  stZ80_EDB2='INIR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDB2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: set'#13#10+
             'S: unknown'#13#10+
             'A byte from port C is written to the memory location pointed to by HL. Then HL is incremented and B is decremented. If B is not zero, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  stZ80_EDB3='OTIR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDB3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: set'#13#10+
             'S: unknown'#13#10+
             'A byte from the memory location pointed to by HL is written to port C. Then HL is incremented and B is decremented. If B is not zero, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  //stZ80_EDB4-stZ80_EDB7 - none
  stZ80_EDB8='LDDR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDB8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: reset'#13#10+
             'P/V: reset'#13#10+
             'H: reset'#13#10+
             'Z: unaffected'#13#10+
             'S: unaffected'#13#10+
             'Transfers a byte of data from the memory location pointed to by HL to the memory location pointed to by DE. Then HL, DE, and BC are decremented. If BC is not zero, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  stZ80_EDB9='CPDR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDB9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: reset'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Compares the value of the memory location pointed to by HL with A. Then HL and BC are decremented. If BC is not zero and Z is not set, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  stZ80_EDBA='INDR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDBA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: set'#13#10+
             'S: unknown'#13#10+
             'A byte from port C is written to the memory location pointed to by HL. Then HL and B are decremented. If B is not zero, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  stZ80_EDBB='OTDR'#13#10+
             'Group: Extended instructions (ED prefix)'#13#10+
             'Opcode: EDBB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 21/16'#13#10+
             'C: unaffected'#13#10+
             'N: set'#13#10+
             'P/V: unknown'#13#10+
             'H: unknown'#13#10+
             'Z: set'#13#10+
             'S: unknown'#13#10+
             'A byte from the memory location pointed to by HL is written to port C. Then HL and B are decremented. If B is not zero, this operation is repeated. Interrupts can trigger while this instruction is processing.';
  //stZ80_EDBC-stZ80_EDBF - none

  //stZ80_EDC0-stZ80_EDFF - none

  stZ80_CB00='RLC B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB00'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB01='RLC C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB01'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB02='RLC D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB02'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB03='RLC E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB03'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB04='RLC H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB04'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB05='RLC L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB05'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB06='RLC (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB06'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB07='RLC A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB07'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are rotated left one bit position. The contents of bit 7 are copied to the carry flag and bit 0.';
  stZ80_CB08='RRC B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB08'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB09='RRC C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB09'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB0A='RRC D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB0A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB0B='RRC E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB0B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB0C='RRC H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB0C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB0D='RRC L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB0D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB0E='RRC (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB0E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';
  stZ80_CB0F='RRC A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB0F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are rotated right one bit position. The contents of bit 0 are copied to the carry flag and bit 7.';

  stZ80_CB10='RL B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB10'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB11='RL C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB11'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB12='RL D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB12'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB13='RL E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB13'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB14='RL H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB14'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB15='RL L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB15'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB16='RL (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB16'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB17='RL A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB17'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are rotated left one bit position. The contents of bit 7 are copied to the carry flag and the previous contents of the carry flag are copied to bit 0.';
  stZ80_CB18='RR B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB18'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB19='RR C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB19'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB1A='RR D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB1A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB1B='RR E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB1B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB1C='RR H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB1C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB1D='RR L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB1D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB1E='RR (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB1E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';
  stZ80_CB1F='RR A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB1F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are rotated right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of the carry flag are copied to bit 7.';

  stZ80_CB20='SLA B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB20'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB21='SLA C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB21'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB22='SLA D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB22'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB23='SLA E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB23'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB24='SLA H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB24'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB25='SLA L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB25'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB26='SLA (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB26'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB27='SLA A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB27'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are shifted left one bit position. The contents of bit 7 are copied to the carry flag and a zero is put into bit 0.';
  stZ80_CB28='SRA B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB28'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB29='SRA C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB29'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB2A='SRA D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB2A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB2B='SRA E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB2B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB2C='SRA H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB2C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB2D='SRA L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB2D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB2E='SRA (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB2E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';
  stZ80_CB2F='SRA A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB2F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are shifted right one bit position. The contents of bit 0 are copied to the carry flag and the previous contents of bit 7 are unchanged.';

  stZ80_CB30='SLL B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB30'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB31='SLL C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB31'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB32='SLL D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB32'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB33='SLL E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB33'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB34='SLL H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB34'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB35='SLL L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB35'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB36='SLL (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB36'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB37='SLL A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: CB37'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are shifted left one bit position. The contents of bit 7 are put into the carry flag and a one is put into bit 0.';
  stZ80_CB38='SRL B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB38'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of B are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB39='SRL C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB39'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of C are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB3A='SRL D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB3A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of D are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB3B='SRL E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB3B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of E are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB3C='SRL H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB3C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of H are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB3D='SRL L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB3D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of L are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB3E='SRL (HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB3E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of (HL) are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';
  stZ80_CB3F='SRL A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB3F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: reset'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'The contents of A are shifted right one bit position. The contents of bit 0 are copied to the carry flag and a zero is put into bit 7.';

  stZ80_CB40='BIT 0,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB40'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of B.';
  stZ80_CB41='BIT 0,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB41'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of C.';
  stZ80_CB42='BIT 0,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB42'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of D.';
  stZ80_CB43='BIT 0,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB43'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of E.';
  stZ80_CB44='BIT 0,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB44'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of H.';
  stZ80_CB45='BIT 0,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB45'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of L.';
  stZ80_CB46='BIT 0,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB46'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of (HL).';
  stZ80_CB47='BIT 0,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB47'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 0 of A.';
  stZ80_CB48='BIT 1,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB48'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of B.';
  stZ80_CB49='BIT 1,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB49'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of C.';
  stZ80_CB4A='BIT 1,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB4A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of D.';
  stZ80_CB4B='BIT 1,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB4B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of E.';
  stZ80_CB4C='BIT 1,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB4C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of H.';
  stZ80_CB4D='BIT 1,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB4D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of L.';
  stZ80_CB4E='BIT 1,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB4E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of (HL).';
  stZ80_CB4F='BIT 1,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB4F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 1 of A.';

  stZ80_CB50='BIT 2,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB50'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of B.';
  stZ80_CB51='BIT 2,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB51'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of C.';
  stZ80_CB52='BIT 2,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB52'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of D.';
  stZ80_CB53='BIT 2,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB53'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of E.';
  stZ80_CB54='BIT 2,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB54'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of H.';
  stZ80_CB55='BIT 2,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB55'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of L.';
  stZ80_CB56='BIT 2,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB56'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of (HL).';
  stZ80_CB57='BIT 2,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB57'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 2 of A.';
  stZ80_CB58='BIT 3,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB58'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of B.';
  stZ80_CB59='BIT 3,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB59'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of C.';
  stZ80_CB5A='BIT 3,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB5A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of D.';
  stZ80_CB5B='BIT 3,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB5B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of E.';
  stZ80_CB5C='BIT 3,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB5C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of H.';
  stZ80_CB5D='BIT 3,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB5D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of L.';
  stZ80_CB5E='BIT 3,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB5E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of (HL).';
  stZ80_CB5F='BIT 3,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB5F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 3 of A.';

  stZ80_CB60='BIT 4,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB60'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of B.';
  stZ80_CB61='BIT 4,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB61'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of C.';
  stZ80_CB62='BIT 4,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB62'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of D.';
  stZ80_CB63='BIT 4,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB63'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of E.';
  stZ80_CB64='BIT 4,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB64'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of H.';
  stZ80_CB65='BIT 4,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB65'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of L.';
  stZ80_CB66='BIT 4,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB66'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of (HL).';
  stZ80_CB67='BIT 4,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB67'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 4 of A.';
  stZ80_CB68='BIT 5,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB68'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of B.';
  stZ80_CB69='BIT 5,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB69'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of C.';
  stZ80_CB6A='BIT 5,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB6A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of D.';
  stZ80_CB6B='BIT 5,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB6B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of E.';
  stZ80_CB6C='BIT 5,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB6C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of H.';
  stZ80_CB6D='BIT 5,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB6D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of L.';
  stZ80_CB6E='BIT 5,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB6E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of (HL).';
  stZ80_CB6F='BIT 5,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB6F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 5 of A.';

  stZ80_CB70='BIT 6,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB70'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of B.';
  stZ80_CB71='BIT 6,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB71'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of C.';
  stZ80_CB72='BIT 6,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB72'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of D.';
  stZ80_CB73='BIT 6,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB73'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of E.';
  stZ80_CB74='BIT 6,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB74'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of H.';
  stZ80_CB75='BIT 6,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB75'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of L.';
  stZ80_CB76='BIT 6,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB76'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of (HL).';
  stZ80_CB77='BIT 6,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB77'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 6 of A.';
  stZ80_CB78='BIT 7,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB78'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of B.';
  stZ80_CB79='BIT 7,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB79'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of C.';
  stZ80_CB7A='BIT 7,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB7A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of D.';
  stZ80_CB7B='BIT 7,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB7B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of E.';
  stZ80_CB7C='BIT 7,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB7C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of H.';
  stZ80_CB7D='BIT 7,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB7D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of L.';
  stZ80_CB7E='BIT 7,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB7E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 12'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of (HL).';
  stZ80_CB7F='BIT 7,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB7F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: reset'#13#10+
             'P/V: unknown'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: unknown'#13#10+
             'Tests bit 7 of A.';

  stZ80_CB80='RES 0,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB80'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of B.';
  stZ80_CB81='RES 0,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB81'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of C.';
  stZ80_CB82='RES 0,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB82'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of D.';
  stZ80_CB83='RES 0,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB83'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of E.';
  stZ80_CB84='RES 0,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB84'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of H.';
  stZ80_CB85='RES 0,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB85'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of L.';
  stZ80_CB86='RES 0,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB86'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of (HL).';
  stZ80_CB87='RES 0,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB87'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 0 of A.';
  stZ80_CB88='RES 1,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB88'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of B.';
  stZ80_CB89='RES 1,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB89'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of C.';
  stZ80_CB8A='RES 1,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB8A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of D.';
  stZ80_CB8B='RES 1,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB8B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of E.';
  stZ80_CB8C='RES 1,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB8C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of H.';
  stZ80_CB8D='RES 1,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB8D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of L.';
  stZ80_CB8E='RES 1,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB8E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of (HL).';
  stZ80_CB8F='RES 1,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB8F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 1 of A.';

  stZ80_CB90='RES 2,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB90'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of B.';
  stZ80_CB91='RES 2,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB91'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of C.';
  stZ80_CB92='RES 2,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB92'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of D.';
  stZ80_CB93='RES 2,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB93'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of E.';
  stZ80_CB94='RES 2,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB94'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of H.';
  stZ80_CB95='RES 2,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB95'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of L.';
  stZ80_CB96='RES 2,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB96'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of (HL).';
  stZ80_CB97='RES 2,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB97'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 2 of A.';
  stZ80_CB98='RES 3,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB98'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of B.';
  stZ80_CB99='RES 3,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB99'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of C.';
  stZ80_CB9A='RES 3,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB9A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of D.';
  stZ80_CB9B='RES 3,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB9B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of B.';
  stZ80_CB9C='RES 3,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB9C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of H.';
  stZ80_CB9D='RES 3,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB9D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of L.';
  stZ80_CB9E='RES 3,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB9E'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of (HL).';
  stZ80_CB9F='RES 3,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CB9F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 3 of A.';

  stZ80_CBA0='RES 4,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of B.';
  stZ80_CBA1='RES 4,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of C.';
  stZ80_CBA2='RES 4,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of D.';
  stZ80_CBA3='RES 4,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of E.';
  stZ80_CBA4='RES 4,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of H.';
  stZ80_CBA5='RES 4,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of L.';
  stZ80_CBA6='RES 4,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA6'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of (HL).';
  stZ80_CBA7='RES 4,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA7'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 4 of A.';
  stZ80_CBA8='RES 5,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of B.';
  stZ80_CBA9='RES 5,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBA9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of C.';
  stZ80_CBAA='RES 5,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBAA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of D.';
  stZ80_CBAB='RES 5,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBAB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of B.';
  stZ80_CBAC='RES 5,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBAC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of H.';
  stZ80_CBAD='RES 5,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBAD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of L.';
  stZ80_CBAE='RES 5,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBAE'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of (HL).';
  stZ80_CBAF='RES 5,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBAF'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 5 of A.';

  stZ80_CBB0='RES 6,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of B.';
  stZ80_CBB1='RES 6,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of C.';
  stZ80_CBB2='RES 6,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of D.';
  stZ80_CBB3='RES 6,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of E.';
  stZ80_CBB4='RES 6,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of H.';
  stZ80_CBB5='RES 6,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of L.';
  stZ80_CBB6='RES 6,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB6'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of (HL).';
  stZ80_CBB7='RES 6,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB7'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 6 of A.';
  stZ80_CBB8='RES 7,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of B.';
  stZ80_CBB9='RES 7,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBB9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of C.';
  stZ80_CBBA='RES 7,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBBA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of D.';
  stZ80_CBBB='RES 7,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBBB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of B.';
  stZ80_CBBC='RES 7,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBBC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of H.';
  stZ80_CBBD='RES 7,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBBD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of L.';
  stZ80_CBBE='RES 7,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBBE'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of (HL).';
  stZ80_CBBF='RES 7,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBBF'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Resets bit 7 of A.';

  stZ80_CBC0='SET 0,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of B.';
  stZ80_CBC1='SET 0,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of C.';
  stZ80_CBC2='SET 0,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of D.';
  stZ80_CBC3='SET 0,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of E.';
  stZ80_CBC4='SET 0,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of H.';
  stZ80_CBC5='SET 0,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of L.';
  stZ80_CBC6='SET 0,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC6'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of (HL).';
  stZ80_CBC7='SET 0,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC7'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 0 of A.';
  stZ80_CBC8='SET 1,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of B.';
  stZ80_CBC9='SET 1,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBC9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of C.';
  stZ80_CBCA='SET 1,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBCA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of D.';
  stZ80_CBCB='SET 1,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBCB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of E.';
  stZ80_CBCC='SET 1,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBCC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of H.';
  stZ80_CBCD='SET 1,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBCD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of L.';
  stZ80_CBCE='SET 1,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBCE'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of (HL).';
  stZ80_CBCF='SET 1,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBCF'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 1 of A.';
  stZ80_CBD0='SET 2,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of B.';
  stZ80_CBD1='SET 2,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of C.';
  stZ80_CBD2='SET 2,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of D.';
  stZ80_CBD3='SET 2,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of E.';
  stZ80_CBD4='SET 2,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of H.';
  stZ80_CBD5='SET 2,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of L.';
  stZ80_CBD6='SET 2,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD6'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of (HL).';
  stZ80_CBD7='SET 2,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD7'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 2 of A.';
  stZ80_CBD8='SET 3,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of B.';
  stZ80_CBD9='SET 3,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBD9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of C.';
  stZ80_CBDA='SET 3,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBDA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of D.';
  stZ80_CBDB='SET 3,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBDB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of E.';
  stZ80_CBDC='SET 3,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBDC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of H.';
  stZ80_CBDD='SET 3,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBDD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of L.';
  stZ80_CBDE='SET 3,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBDE'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of (HL).';
  stZ80_CBDF='SET 3,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBDF'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 3 of A.';

  stZ80_CBE0='SET 4,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of B.';
  stZ80_CBE1='SET 4,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of C.';
  stZ80_CBE2='SET 4,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of D.';
  stZ80_CBE3='SET 4,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of E.';
  stZ80_CBE4='SET 4,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of H.';
  stZ80_CBE5='SET 4,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of L.';
  stZ80_CBE6='SET 4,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE6'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of (HL).';
  stZ80_CBE7='SET 4,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE7'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 4 of A.';
  stZ80_CBE8='SET 5,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of B.';
  stZ80_CBE9='SET 5,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBE9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of C.';
  stZ80_CBEA='SET 5,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBEA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of D.';
  stZ80_CBEB='SET 5,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBEB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of E.';
  stZ80_CBEC='SET 5,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBEC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of H.';
  stZ80_CBED='SET 5,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBED'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of L.';
  stZ80_CBEE='SET 5,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBEE'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of (HL).';
  stZ80_CBEF='SET 5,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBEF'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 5 of A.';

  stZ80_CBF0='SET 6,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF0'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of B.';
  stZ80_CBF1='SET 6,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of C.';
  stZ80_CBF2='SET 6,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF2'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of D.';
  stZ80_CBF3='SET 6,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of E.';
  stZ80_CBF4='SET 6,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of H.';
  stZ80_CBF5='SET 6,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of L.';
  stZ80_CBF6='SET 6,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF6'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of (HL).';
  stZ80_CBF7='SET 6,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF7'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 6 of A.';
  stZ80_CBF8='SET 7,B'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF8'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of B.';
  stZ80_CBF9='SET 7,C'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBF9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of C.';
  stZ80_CBFA='SET 7,D'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBFA'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of D.';
  stZ80_CBFB='SET 7,E'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBFB'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of E.';
  stZ80_CBFC='SET 7,H'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBFC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of H.';
  stZ80_CBFD='SET 7,L'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBFD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of L.';
  stZ80_CBFE='SET 7,(HL)'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBFE'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of (HL).';
  stZ80_CBFF='SET 7,A'#13#10+
             'Group: Bit instructions (CB prefix)'#13#10+
             'Opcode: CBFF'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Sets bit 7 of A.';

  //stZ80_DD00-stZ80_DD08 - none
  stZ80_DD09='ADD IX,BC'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD09'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: unafeccted'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The value of BC is added to IX.';
  //stZ80_DD0A-stZ80_DD0F - none

  //stZ80_DD10-stZ80_DD18 - none
  stZ80_DD19='ADD IX,DE'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD19'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: unafeccted'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The value of DE is added to IX.';
  //stZ80_DD1A-stZ80_DD1F - none

  //stZ80_DD20 - none
  stZ80_DD21='LD IX,**'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD21'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads ** into register IX.';
  stZ80_DD22='LD (**),IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD22'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores IX into the memory location pointed to by **.';
  stZ80_DD23='INC IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD23'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 10'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Adds one to IX.';
  stZ80_DD24='INC IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD24'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds one to IXH.';
  stZ80_DD25='DEC IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD25'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts one from IXH.';
  stZ80_DD26='LD IXH,*'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD26'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 11'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads * into IXH.';
  //stZ80_DD27-stZ80_DD28 - none
  stZ80_DD29='ADD IX,IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD29'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: unafeccted'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The value of IX is added to IX.';
  stZ80_DD2A='LD IX,(**)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD2A'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 20'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by ** into IX.';
  stZ80_DD2B='DEC IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD2B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 10'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Subtracts one from IX.';
  stZ80_DD2C='INC IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD2C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds one to IXL.';
  stZ80_DD2D='DEC IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD2D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts one from IXL.';
  stZ80_DD2E='LD IXL,*'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD2E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 11'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads * into IXL.';
  //stZ80_DD2F - none

  //stZ80_DD30-stZ80_DD33 - none
  stZ80_DD34='INC (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD34'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 23'#13#10+
             'C: unafeccted'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds one to the memory location pointed to by IX plus *.';
  stZ80_DD35='DEC (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD35'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 23'#13#10+
             'C: unafeccted'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts one from the memory location pointed to by IX plus *.';
  stZ80_DD36='LD (IX+*),*'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD36'#13#10+
             'Size (bytes): 4'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores * to the memory location pointed to by IX plus *.';
  //stZ80_DD37-stZ80_DD38 - none
  stZ80_DD39='ADD IX,SP'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD39'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: unafeccted'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The value of SP is added to IX.';
  //stZ80_DD3A-stZ80_DD3F - none

  //stZ80_DD40-stZ80_DD43 - none
  stZ80_DD44='LD B,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD44'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into B.';
  stZ80_DD45='LD B,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD45'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXl are loaded into B.';
  stZ80_DD46='LD B,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD46'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into B.';
  //stZ80_DD47-stZ80_DD4B - none
  stZ80_DD4C='LD C,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD4C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into C.';
  stZ80_DD4D='LD C,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD4D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXl are loaded into C.';
  stZ80_DD4E='LD C,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD4E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into C.';
  //stZ80_DD4F - none

  //stZ80_DD50-stZ80_DD53 - none
  stZ80_DD54='LD D,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD54'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into D.';
  stZ80_DD55='LD D,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD55'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXl are loaded into D.';
  stZ80_DD56='LD D,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD56'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into D.';
  //stZ80_DD57-stZ80_DD5B - none
  stZ80_DD5C='LD E,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD5C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into E.';
  stZ80_DD5D='LD E,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD5D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXl are loaded into E.';
  stZ80_DD5E='LD E,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD5E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into E.';
  //stZ80_DD5F - none

  stZ80_DD60='LD IXH,B'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD60'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of B are loaded into IXH.';
  stZ80_DD61='LD IXH,C'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD61'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of C are loaded into IXH.';
  stZ80_DD62='LD IXH,D'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD62'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of D are loaded into IXH.';
  stZ80_DD63='LD IXH,E'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD63'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of E are loaded into IXH.';
  stZ80_DD64='LD IXH,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD64'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into IXH.';
  stZ80_DD65='LD IXH,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD65'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXL are loaded into IXH.';
  stZ80_DD66='LD H,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD66'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into H.';
  stZ80_DD67='LD IXH,A'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD67'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of A are loaded into IXH.';
  stZ80_DD68='LD IXL,B'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD68'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of B are loaded into IXL.';
  stZ80_DD69='LD IXL,C'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD69'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of C are loaded into IXL.';
  stZ80_DD6A='LD IXL,D'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD6A'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of D are loaded into IXL.';
  stZ80_DD6B='LD IXL,E'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD6B'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of E are loaded into IXL.';
  stZ80_DD6C='LD IXL,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD6C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into IXL.';
  stZ80_DD6D='LD IXL,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD6D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXL are loaded into IXL.';
  stZ80_DD6E='LD L,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD6E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into L.';
  stZ80_DD6F='LD IXL,A'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD6F'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of A are loaded into IXL.';

  stZ80_DD70='LD (IX+*),B'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD70'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores B to the memory location pointed to by IX plus *.';
  stZ80_DD71='LD (IX+*),C'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD71'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores C to the memory location pointed to by IX plus *.';
  stZ80_DD72='LD (IX+*),D'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD72'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores D to the memory location pointed to by IX plus *.';
  stZ80_DD73='LD (IX+*),E'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD73'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores E to the memory location pointed to by IX plus *.';
  stZ80_DD74='LD (IX+*),H'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD74'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores H to the memory location pointed to by IX plus *.';
  stZ80_DD75='LD (IX+*),L'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD75'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores L to the memory location pointed to by IX plus *.';
  //stZ80_DD76 - none
  stZ80_DD77='LD (IX+*),A'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD77'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Stores A to the memory location pointed to by IX plus *.';
  //stZ80_DD78-stZ80_DD7B - none
  stZ80_DD7C='LD A,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD7C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXH are loaded into A.';
  stZ80_DD7D='LD A,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD7D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'The contents of IXL are loaded into A.';
  stZ80_DD7E='LD A,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD7E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: unafeccted'#13#10+
             'N: unafeccted'#13#10+
             'P/V: unafeccted'#13#10+
             'H: unafeccted'#13#10+
             'Z: unafeccted'#13#10+
             'S: unafeccted'#13#10+
             'Loads the value pointed to by IX plus * into A.';
  //stZ80_DD7F - none

  //stZ80_DD80-stZ80_DD83 - none
  stZ80_DD84='ADD A,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD84'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds IXH to A.';
  stZ80_DD85='ADD A,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD85'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds IXL to A.';
  stZ80_DD86='ADD A,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD86'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds the value pointed to by IX plus * to A.';
  //stZ80_DD87-stZ80_DD8B - none
  stZ80_DD8C='ADC A,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD8C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds IXH and the carry flag to A.';
  stZ80_DD8D='ADC A,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD8D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds IXL and the carry flag to A.';
  stZ80_DD8E='ADC A,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD8E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Adds the value pointed to by IX plus * and the carry flag to A.';
  //stZ80_DD8F - none

  //stZ80_DD90-stZ80_DD93 - none
  stZ80_DD94='SUB IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD94'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts IXH from A.';
  stZ80_DD95='SUB IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD95'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts IXL from A.';
  stZ80_DD96='SUB (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD96'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts the value pointed to by IX plus * from A.';
  //stZ80_DD97-stZ80_DD9B - none
  stZ80_DD9C='SBC A,IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD9C'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts IXH and the carry flag from A.';
  stZ80_DD9D='SBC A,IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DD9D'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts IXL and the carry flag from A.';
  stZ80_DD9E='SBC A,(IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DD9E'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts the value pointed to by IX plus * and the carry flag from A.';
  //stZ80_DD9F - none

  //stZ80_DDA0-stZ80_DDA3 - none
  stZ80_DDA4='AND IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDA4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise AND on A with IXH.';
  stZ80_DDA5='AND IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDA5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise AND on A with IXL.';
  stZ80_DDA6='AND (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDA6'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise AND on A with the value pointed to by IX plus *.';
  //stZ80_DDA7-stZ80_DDAB - none
  stZ80_DDAC='XOR IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDAC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise XOR on A with IXH.';
  stZ80_DDAD='XOR IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDAD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise XOR on A with IXL.';
  stZ80_DDAE='XOR (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDAE'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise XOR on A with the value pointed to by IX plus *.';
  //stZ80_DDAF - none

  //stZ80_DDB0-stZ80_DDB3 - none
  stZ80_DDB4='OR IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDB4'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise OR on A with IXH.';
  stZ80_DDB5='OR IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDB5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise OR on A with IXL.';
  stZ80_DDB6='OR (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDB6'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: reset'#13#10+
             'N: reset'#13#10+
             'P/V: detects parity'#13#10+
             'H: set'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Bitwise OR on A with the value pointed to by IX plus *.';
  //stZ80_DDB7-stZ80_DDBB - none
  stZ80_DDBC='CP IXH'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDBC'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts IXH from A and affects flags according to the result. A is not modified.';
  stZ80_DDBD='CP IXL'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             '* UNDOCUMENTED *'#13#10+
             'Opcode: DDBD'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts IXL from A and affects flags according to the result. A is not modified.';
  stZ80_DDBE='CP (IX+*)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDBE'#13#10+
             'Size (bytes): 3'#13#10+
             'Time (clock cycles): 19'#13#10+
             'C: afeccted as defined'#13#10+
             'N: afeccted as defined'#13#10+
             'P/V: detects overflow'#13#10+
             'H: afeccted as defined'#13#10+
             'Z: afeccted as defined'#13#10+
             'S: afeccted as defined'#13#10+
             'Subtracts the value pointed to by IX plus * from A and affects flags according to the result. A is not modified.';
  //stZ80_DDBF - none

  //stZ80_DDC0-stZ80_DDCA - none
  //stZ80_DDCB - IX Bit instructions prefix
  //stZ80_DDCC-stZ80_DDCF - none

  //stZ80_DDD0-stZ80_DDDF - none

  //stZ80_DDE0 - none
  stZ80_DDE1='POP IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDE1'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 14'#13#10+
             'C: unafected'#13#10+
             'N: unafected'#13#10+
             'P/V: unafected'#13#10+
             'H: unafected'#13#10+
             'Z: unafected'#13#10+
             'S: unafected'#13#10+
             'The memory location pointed to by SP is stored into IXL and SP is incremented. The memory location pointed to by SP is stored into IXH and SP is incremented again.';
  //stZ80_DDE2 - none
  stZ80_DDE3='EX (SP),IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDE3'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 23'#13#10+
             'C: unafected'#13#10+
             'N: unafected'#13#10+
             'P/V: unafected'#13#10+
             'H: unafected'#13#10+
             'Z: unafected'#13#10+
             'S: unafected'#13#10+
             'Exchanges (SP) with the IXL, and (SP+1) with the IXH.';
  //stZ80_DDE4 - none
  stZ80_DDE5='PUSH IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDE5'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 15'#13#10+
             'C: unafected'#13#10+
             'N: unafected'#13#10+
             'P/V: unafected'#13#10+
             'H: unafected'#13#10+
             'Z: unafected'#13#10+
             'S: unafected'#13#10+
             'SP is decremented and IXH is stored into the memory location pointed to by SP. SP is decremented again and IXL is stored into the memory location pointed to by SP.';
  //stZ80_DDE6-stZ80_DDE8 - none
  stZ80_DDE9='JP (IX)'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDE9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 8'#13#10+
             'C: unafected'#13#10+
             'N: unafected'#13#10+
             'P/V: unafected'#13#10+
             'H: unafected'#13#10+
             'Z: unafected'#13#10+
             'S: unafected'#13#10+
             'Loads the value of IX into PC.';
  //stZ80_DDEA-stZ80_DDEF - none

  //stZ80_DDF0-stZ80_DDF8 - none
  stZ80_DDF9='LD SP,IX'#13#10+
             'Group: IX instructions (DD prefix)'#13#10+
             'Opcode: DDF9'#13#10+
             'Size (bytes): 2'#13#10+
             'Time (clock cycles): 10'#13#10+
             'C: unafected'#13#10+
             'N: unafected'#13#10+
             'P/V: unafected'#13#10+
             'H: unafected'#13#10+
             'Z: unafected'#13#10+
             'S: unafected'#13#10+
             'Loads the value of IX into SP.';
  //stZ80_DDFA-stZ80_DDFF - none
  {

  }

implementation

end.
